<?php

namespace FoodSearch\Dashboard_Settings;
use FoodSearch\Dashboard_Settings\Restaurant_Builder as Restaurant_Builder;
use FoodSearch\Dashboard_Settings\Customer_Builder as Customer_Builder;
use FoodSearch\Common_Functions;

class Menu_Section_Elements {
    
    public function element($builder_type = 'restaurant', $element_type = 'account_settings', $element_id = 0, $elem_data = array()) {
        
        global $foodsearch_form_fields;
        
        $rand_num = rand(1000000, 9999999);
        
        $common_functions = new Common_Functions;
        
        $elem_id = $rand_num;
        if ($element_id > 0) {
            $elem_id = $element_id;
        }
        
        $elem_label = $saved_elem_label = $padding_top = $padding_right = $padding_bottom = $padding_left = '';
        
        $margin_top = $margin_right = $margin_bottom = $margin_left = '';
        
        $builder_obj = new Restaurant_Builder;
        if ($builder_type == 'customer') {
            $builder_obj = new Customer_Builder;
        }
        
        $orig_elem_fields = $elem_fields = '';
        
        $sect_elems = $builder_obj->dashboard_menu_elements_list();
        if (isset($sect_elems[$element_type])) {
            $elem_label = $sect_elems[$element_type]['label'];
            
            $orig_elem_fields = $elem_fields = isset($sect_elems[$element_type]['fields']) ? $sect_elems[$element_type]['fields'] : '';
        }

        $elem_pos = 0;
        $addin_element = true;
        if (isset($elem_data['sort'])) {
            $addin_element = false;
            $elem_pos = isset($elem_data['sort']) ? $elem_data['sort'] : '';
            $saved_elem_label = isset($elem_data['label']) ? $elem_data['label'] : '';
            
            if (isset($elem_data['item_fields']) && !empty($elem_data['item_fields'])) {
                $elem_fields = $elem_data['item_fields'];
                $elem_fields = $common_functions->array_merge_with_keys($orig_elem_fields, $elem_fields);
                uasort($elem_fields, function ($a, $b) {
                    if ($a['sort'] == $b['sort']) {
                        $ret_val = 0;
                    }
                    $ret_val = ($a['sort'] < $b['sort']) ? -1 : 1;
                    return $ret_val;
                });
            }
        }
        ob_start();
        ?>
        <div id="dashb-elem-itm<?php echo ($elem_id) ?>" data-id="<?php echo ($elem_id) ?>" data-type="<?php echo ($element_type) ?>" class="sect-elemnt-itmcon">
            <div class="elem-conitm-hder">
                <div class="elem-itm-label">
                    <a class="elemn-itm-sorter fds-link"><i class="fds-icon fds-move-drager"></i></a>
                    <a href="javascript:void(0);" class="elem-itm-lablholdr fds-link" onclick="foodsearch_dashboard_builder.open_elemitm_conholdr(this);"><strong><?php echo ($elem_label) ?></strong></a>
                </div>
                <div class="elem-hdr-btns">
                    <a href="javascript:void(0);" class="dashb-elem-updatebtn fds-link" onclick="foodsearch_dashboard_builder.<?php echo (!empty($elem_fields) ? 'open_elmitems_consetin_trigr' : 'open_elemitm_conholdr') ?>(this);"><i class="dashicons-before dashicons-admin-generic"></i></a>
                    <a href="javascript:void(0);" class="dashb-elem-remvebtn fds-link" onclick="foodsearch_dashboard_builder.remove_elemitm_by_id(this);"><i class="dashicons-before dashicons-trash"></i></a>
                </div>
                <input type="hidden" name="menu_sectelem_items[<?php echo ($elem_id) ?>][sort]" value="<?php echo ($elem_pos) ?>">
                <input type="hidden" name="menu_sectelem_items[<?php echo ($elem_id) ?>][type]" value="<?php echo ($element_type) ?>">
            </div>
            <div class="elem-conitm-contnt" style="display: none;">
                <?php
                if (!empty($elem_fields)) {
                    ?>

                    <div class="elem-fields-hldrcon">
                        <?php
                        foreach ($elem_fields as $item_key => $item_data) {
                            $this->element_item($builder_type, $item_key, $item_data, $elem_id, $orig_elem_fields);
                        }
                        ?>
                    </div>
                    <?php
                }
                ?>
                <div class="elem-setins-con"<?php echo (!empty($elem_fields) ? ' style="display:none;"' : '') ?>>
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('label', 'wp-foodsearch') ?></label></div>
                        <input type="text" name="menu_sectelem_items[<?php echo ($elem_id) ?>][label]" class="fds-input-style" value="<?php echo ($saved_elem_label) ?>">
                    </div>
                    <?php
                    if ($element_type == 'custom_box') {
                        ?>
                        <div class="fds-form-field">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('content', 'wp-foodsearch'); ?></label></div>
                            <?php
                            $editor_id = 'custom-content-' . $elem_id;
                            $editor_settings = array(
                                'media_buttons' => false,
                                'textarea_name' => 'menu_sectelem_items[' . $elem_id . '][content]',
                                'quicktags' => array('buttons' => 'strong,em,del,ul,ol,li,close'),
                                'tinymce' => array(
                                    'toolbar1' => 'bold,bullist,numlist,italic,underline,alignleft,aligncenter,alignright,separator,link,unlink,undo,redo,caned_resp_button',
                                    'toolbar2' => '',
                                    'toolbar3' => '',
                                ),
                            );
                            $cus_contnt_value = isset($elem_data['content']) ? $elem_data['content'] : '';
                            wp_editor($cus_contnt_value, $editor_id, $editor_settings);

                            if ($addin_element) {
                                ?>
                                <script>
                                    setTimeout(function() {
                                        tinymce.execCommand('mceAddEditor', true, '<?php echo ($editor_id) ?>');
                                        quicktags({id : "<?php echo ($editor_id) ?>"});
                                    }, 500);
                                </script>
                                <?php
                            }
                            ?>
                        </div>
                        <?php
                    }
                    if ($element_type == 'logo_cover' || $element_type == 'profile_image') {
                        ?>
                        <div class="fds-form-field">
                            <?php
                            $field_label = esc_html__('upload profile/cover photo', 'wp-foodsearch');
                            if ($builder_type == 'restaurant') {
                                $field_label = esc_html__('upload logo/cover', 'wp-foodsearch');
                            }
                            $switch_id = 'profphoto-' . $elem_id;
                            $switch_name = 'menu_sectelem_items[' . $elem_id . '][photo]';
                            $switch_value = isset($elem_data['photo']) ? $elem_data['photo'] : 'on';
                            $this->switch_button($switch_id, $switch_name, $switch_value, $field_label);
                            ?>
                        </div>
                        <?php
                        
                        $pic_size = isset($elem_data['pic_size']) ? $elem_data['pic_size'] : '200';
                        $pic_file_size = isset($elem_data['pic_file_size']) ? $elem_data['pic_file_size'] : '5120';
                        
                        $file_sizes = array(
                            '300' => esc_html__('300kb', 'wp-foodsearch'),
                            '500' => esc_html__('500kb', 'wp-foodsearch'),
                            '750' => esc_html__('750kb', 'wp-foodsearch'),
                            '1024' => esc_html__('1mb', 'wp-foodsearch'),
                            '2048' => esc_html__('2mb', 'wp-foodsearch'),
                            '3072' => esc_html__('3mb', 'wp-foodsearch'),
                            '4096' => esc_html__('4mb', 'wp-foodsearch'),
                            '5120' => esc_html__('5mb', 'wp-foodsearch'),
                            '10120' => esc_html__('10mb', 'wp-foodsearch'),
                            '50120' => esc_html__('50mb', 'wp-foodsearch'),
                            '100120' => esc_html__('100mb', 'wp-foodsearch'),
                            '200120' => esc_html__('200mb', 'wp-foodsearch'),
                            '300120' => esc_html__('300mb', 'wp-foodsearch'),
                            '500120' => esc_html__('500mb', 'wp-foodsearch'),
                            '1000120' => esc_html__('1gb', 'wp-foodsearch'),
                        );
                        ?>
                        <div class="fds-form-field">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('picture size', 'wp-foodsearch') ?></label></div>
                            <input type="number" name="menu_sectelem_items[<?php echo ($elem_id) ?>][pic_size]" class="fds-input-style" value="<?php echo ($pic_size) ?>">
                        </div>
                        <div class="fds-form-field fds-select-field">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('picture file size', 'wp-foodsearch') ?></label></div>
                            <select name="menu_sectelem_items[<?php echo ($elem_id) ?>][pic_file_size]" data-placeholder="<?php esc_html_e('select size', 'wp-foodsearch') ?>" class="fds-select-dropdown">
                                <option value=""><?php esc_html_e('select size', 'wp-foodsearch') ?></option>
                                <?php
                                foreach ($file_sizes as $filesiz_key => $filesiz_labl) {
                                    ?>
                                    <option value="<?php echo ($filesiz_key) ?>"<?php echo ($filesiz_key == $pic_file_size ? ' selected' : '') ?>><?php echo ($filesiz_labl) ?></option>
                                    <?php
                                }
                                ?>
                            </select>
                        </div>
                        <?php
                        if ($builder_type == 'restaurant') {
                            $cover_file_size = isset($elem_data['cover_file_size']) ? $elem_data['cover_file_size'] : '5120';
                            ?>
                            <div class="fds-form-field fds-select-field">
                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('cover photo file size', 'wp-foodsearch') ?></label></div>
                                <select name="menu_sectelem_items[<?php echo ($elem_id) ?>][cover_file_size]" data-placeholder="<?php esc_html_e('select size', 'wp-foodsearch') ?>" class="fds-select-dropdown">
                                    <option value=""><?php esc_html_e('select size', 'wp-foodsearch') ?></option>
                                    <?php
                                    foreach ($file_sizes as $filesiz_key => $filesiz_labl) {
                                        ?>
                                        <option value="<?php echo ($filesiz_key) ?>"<?php echo ($filesiz_key == $cover_file_size ? ' selected' : '') ?>><?php echo ($filesiz_labl) ?></option>
                                        <?php
                                    }
                                    ?>
                                </select>
                            </div>
                            <?php
                        }
                    }
                    //
                    $padding_top = isset($elem_data['padding_top']) ? $elem_data['padding_top'] : '';
                    $padding_right = isset($elem_data['padding_right']) ? $elem_data['padding_right'] : '';
                    $padding_bottom = isset($elem_data['padding_bottom']) ? $elem_data['padding_bottom'] : '';
                    $padding_left = isset($elem_data['padding_left']) ? $elem_data['padding_left'] : '';

                    $margin_top = isset($elem_data['margin_top']) ? $elem_data['margin_top'] : '';
                    $margin_right = isset($elem_data['margin_right']) ? $elem_data['margin_right'] : '';
                    $margin_bottom = isset($elem_data['margin_bottom']) ? $elem_data['margin_bottom'] : '';
                    $margin_left = isset($elem_data['margin_left']) ? $elem_data['margin_left'] : '';
                    
                    $field_args = array(
                        'name' => 'menu_sectelem_items[' . $elem_id . ']',
                        'values' => array(
                            'padding' => array(
                                'top' => $padding_top,
                                'right' => $padding_right,
                                'bottom' => $padding_bottom,
                                'left' => $padding_left,
                            ),
                            'margin' => array(
                                'top' => $margin_top,
                                'right' => $margin_right,
                                'bottom' => $margin_bottom,
                                'left' => $margin_left,
                            ),
                        ),
                    );
                    $foodsearch_form_fields->padding_margin($field_args);
                    ?>
                </div>
            </div>
        </div>
        <?php
        $html = ob_get_clean();
        
        return $html;
    }
    
    public function switch_button($id, $name, $value, $label) {
        ?>
        <div class="label_wrap"><label class="fds-input-label"><?php echo ($label) ?></label></div>
        <label for="<?php echo ($id) ?>" class="fds-switch fds-input-label">
            <input id="<?php echo ($id) ?>" type="checkbox" class="fds-settings-switch"<?php echo ($value == 'on' ? ' checked' : '') ?>>
            <strong class="fds-switch-inn">
                <span class="fds-off-switch"><?php echo esc_html_e('off', 'wp-foodsearch') ?></span>
                <span class="fds-on-switch"><?php echo esc_html_e('on', 'wp-foodsearch') ?></span>
            </strong>
            <input type="hidden" name="<?php echo ($name) ?>" value="<?php echo ($value) ?>">
        </label>
        <?php
    }

    public function element_item($builder_type, $item_key, $item_data, $elem_id, $orig_elem_fields) {
        $item_label = $item_data['label'];
        $item_pos = isset($item_data['sort']) ? $item_data['sort'] : 0;
        
        $orig_field = isset($orig_elem_fields[$item_key]) ? $orig_elem_fields[$item_key] : '';
        ?>
        <div class="elem-itm-mcon" data-key="<?php echo ($item_key) ?>">
            <div class="elem-emitm-hder">
                <div class="elem-emitm-label">
                    <a class="elemn-emitm-sorter fds-link"><i class="fds-icon fds-move-drager"></i></a>
                    <a href="javascript:void(0);" class="elem-emitm-lablholdr fds-link" onclick="foodsearch_dashboard_builder.open_elemitm_singsetins(this);"><strong><?php echo ($item_label) ?></strong></a>
                </div>
                <div class="elem-emhdr-btns">
                    <a href="javascript:void(0);" class="dashb-emelem-updatebtn fds-link" onclick="foodsearch_dashboard_builder.open_elemitm_singsetins(this);"><i class="dashicons-before dashicons-admin-generic"></i></a>
                </div>
                <input type="hidden" class="elem-item-sort<?php echo ($elem_id) ?>" name="sectelem_item_setins[<?php echo ($elem_id) ?>][<?php echo ($item_key) ?>][sort]" value="<?php echo ($item_pos) ?>">
            </div>
            <div class="elem-emitm-settins" style="display:none;">
                <div class="fds-form-field">
                    <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('label', 'wp-foodsearch') ?></label></div>
                    <input type="text" name="sectelem_item_setins[<?php echo ($elem_id) ?>][<?php echo ($item_key) ?>][label]" class="fds-input-style" value="<?php echo ($item_label) ?>">
                </div>
                <div class="fds-form-field">
                    <?php
                    $switch_label = esc_html__('enable field', 'wp-foodsearch');
                    $switch_id = 'status-' . $elem_id . '-' . $item_key;
                    $switch_name = 'sectelem_item_setins[' . $elem_id . '][' . $item_key . '][status]';
                    $switch_value = isset($item_data['status']) ? $item_data['status'] : 'on';
                    $this->switch_button($switch_id, $switch_name, $switch_value, $switch_label);
                    ?>
                </div>

                <div class="fds-form-field">
                    <?php
                    //
                    $switch_label = esc_html__('required field', 'wp-foodsearch');
                    $switch_id = 'required-' . $elem_id . '-' . $item_key;
                    $switch_name = 'sectelem_item_setins[' . $elem_id . '][' . $item_key . '][required]';
                    $switch_value = isset($item_data['required']) ? $item_data['required'] : '';
                    $this->switch_button($switch_id, $switch_name, $switch_value, $switch_label);

                    $column_width = isset($item_data['width']) ? $item_data['width'] : '2';
                    ?>
                </div>
                <?php
                if (isset($orig_field['full_col']) && $orig_field['full_col'] === true) {
                    ?>
                    <input type="hidden" name="sectelem_item_setins[<?php echo ($elem_id) ?>][<?php echo ($item_key) ?>][width]" value="1">
                    <?php
                } else {
                    ?>
                    <div class="fds-form-field fds-select-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('column width', 'wp-foodsearch') ?></label></div>
                        <select name="sectelem_item_setins[<?php echo ($elem_id) ?>][<?php echo ($item_key) ?>][width]" data-placeholder="<?php esc_html_e('select column', 'wp-foodsearch') ?>" class="fds-select-dropdown">
                            <option value=""><?php esc_html_e('select column', 'wp-foodsearch') ?></option>
                            <option value="1"<?php echo ($column_width == '1' ? ' selected' : '') ?>><?php esc_html_e('1 column', 'wp-foodsearch') ?></option>
                            <option value="2"<?php echo ($column_width == '2' ? ' selected' : '') ?>><?php esc_html_e('2 column', 'wp-foodsearch') ?></option>
                            <option value="3"<?php echo ($column_width == '3' ? ' selected' : '') ?>><?php esc_html_e('3 column', 'wp-foodsearch') ?></option>
                            <option value="4"<?php echo ($column_width == '4' ? ' selected' : '') ?>><?php esc_html_e('4 column', 'wp-foodsearch') ?></option>
                            <option value="5"<?php echo ($column_width == '5' ? ' selected' : '') ?>><?php esc_html_e('5 column', 'wp-foodsearch') ?></option>
                            <option value="6"<?php echo ($column_width == '6' ? ' selected' : '') ?>><?php esc_html_e('6 column', 'wp-foodsearch') ?></option>
                        </select> 
                    </div>
                    <?php
                }
                ?>
            </div>
        </div>
        <?php
    }

}

new Menu_Section_Elements;
