<?php

namespace FoodSearch\Dashboard_Settings;

use FoodSearch\Dashboard_Settings\Common_Functions as Common_Functions;
use FoodSearch\Dashboard_Settings\Menu_Section_Elements as Section_Elements;

class Rest_APIs {

    public function __construct() {
        add_action('rest_api_init', array($this, 'register_api'));
    }
    
    public function register_api() {

        register_rest_route('wp/v1', 'add-dashboard-sidemenu', array(
            'methods' => 'POST',
            'callback' => array($this, 'add_dashboard_menu'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'saving-dashboard-menu-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'save_dashbmenu_byid'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'remove-dashboard-menu-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'remove_dashbmenu_byid'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'adding-section-inmenu', array(
            'methods' => 'POST',
            'callback' => array($this, 'add_dashbmenu_section'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'saving-menu-section-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'savin_menu_sec_byid'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'remove-menu-sec-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'remove_menu_sec_byid'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'add-element-in-section', array(
            'methods' => 'POST',
            'callback' => array($this, 'add_element_in_section'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'saving-section-element-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'save_element_in_section'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));
        
        register_rest_route('wp/v1', 'saving-sect-onlyelemnt-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'save_sect_onlyelem_byid'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));
        
        register_rest_route('wp/v1', 'saving-element-field-setins', array(
            'methods' => 'POST',
            'callback' => array($this, 'save_element_field_setins'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'remove-sec-element-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'remove_element_by_id'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'move-secelement-to-other', array(
            'methods' => 'POST',
            'callback' => array($this, 'move_secelement_to_other'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));
                
        register_rest_route('wp/v1', 'sort-dashb-menu-items', array(
            'methods' => 'POST',
            'callback' => array($this, 'sort_dashb_menu_itms'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));
                
        register_rest_route('wp/v1', 'sort-dashb-menu-sects', array(
            'methods' => 'POST',
            'callback' => array($this, 'sort_menu_sections'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'sort-dashb-sec-elements', array(
            'methods' => 'POST',
            'callback' => array($this, 'sort_section_elements'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'sort-dashb-elem-fields', array(
            'methods' => 'POST',
            'callback' => array($this, 'sort_element_fields'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));

        register_rest_route('wp/v1', 'set-dash-builder-menu-slug', array(
            'methods' => 'POST',
            'callback' => array($this, 'create_menu_slug'),
            'permission_callback' =>  'admin_permissions_check',
            'args' => [
                '_wp_nonce' => [
                    'validate_callback' => function ($wp_nonce) {
                        return wp_verify_nonce($wp_nonce, 'foodsearch-dashbilder-nonce');
                    }
                ]
            ]
        ));
    }


    public function add_dashboard_menu() {
        $response = array();
        
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $html = $common_functions->menu_item_html($builder_type);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('menu added successfully.', 'wp-foodsearch');
        $response['html'] = $html;

        wp_send_json($response);
    }

    public function save_dashbmenu_byid() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->save_menu_byid($menu_id, $builder_type, $_REQUEST);
        $response['msg'] = esc_html__('settings saved successfully.', 'wp-foodsearch');
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function remove_dashbmenu_byid() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->remove_menu_byid($menu_id, $builder_type);
        $response['msg'] = esc_html__('menu item deleted from list.', 'wp-foodsearch');
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function add_dashbmenu_section() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $html = $common_functions->menu_item_section();
        $response['status'] = 'success';
        $response['msg'] = esc_html__('section added in menu successfully.', 'wp-foodsearch');
        $response['html'] = $html;

        wp_send_json($response);
    }

    public function savin_menu_sec_byid() {
        $response = array();
        
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->save_menu_sec_byid($menu_id, $section_id, $builder_type, $_REQUEST);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('settings saved successfully.', 'wp-foodsearch');

        wp_send_json($response);
    }
    
    public function remove_menu_sec_byid() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $elems_list = $common_functions->section_elements_list($builder_type, $menu_id, $section_id);
        $elems_list = empty($elems_list) ? '' : implode(',', $elems_list);
        //
        $common_functions->remove_menu_sec_byid($menu_id, $section_id, $builder_type);

        $response['status'] = 'success';
        $response['msg'] = esc_html__('section deleted from menu.', 'wp-foodsearch');
        $response['elems'] = $elems_list;

        wp_send_json($response);
    }
    
    public function add_element_in_section() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        $elemnt_type = isset($_REQUEST['elemnt_type']) ? $_REQUEST['elemnt_type'] : '';
        
        $sect_elements = new Section_Elements;
        
        $html = $sect_elements->element($builder_type, $elemnt_type);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('element added in section successfully.', 'wp-foodsearch');
        $response['html'] = $html;

        wp_send_json($response);
    }
    
    public function save_element_in_section() {
        $response = array();
        
        $element_id = isset($_REQUEST['element_id']) ? $_REQUEST['element_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->save_sec_elem_byid($menu_id, $element_id, $section_id, $builder_type, $_REQUEST);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('settings saved successfully.', 'wp-foodsearch');

        wp_send_json($response);
    }
    
    public function save_sect_onlyelem_byid() {
        $response = array();
        
        $element_id = isset($_REQUEST['element_id']) ? $_REQUEST['element_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->save_sec_onlyelem_byid($menu_id, $element_id, $section_id, $builder_type, $_REQUEST);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('settings saved successfully.', 'wp-foodsearch');

        wp_send_json($response);
    }
    
    public function save_element_field_setins() {
        $response = array();
        
        $field_key = isset($_REQUEST['field_key']) ? $_REQUEST['field_key'] : '';
        $element_id = isset($_REQUEST['element_id']) ? $_REQUEST['element_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->save_elem_field_setins($menu_id, $section_id, $element_id, $field_key, $builder_type, $_REQUEST);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('settings saved successfully.', 'wp-foodsearch');

        wp_send_json($response);
    }
    
    public function remove_element_by_id() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $element_id = isset($_REQUEST['element_id']) ? $_REQUEST['element_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->remove_sect_elem_byid($menu_id, $section_id, $element_id, $builder_type);
        $response['status'] = 'success';
        $response['msg'] = esc_html__('item deleted from this section.', 'wp-foodsearch');

        wp_send_json($response);
    }
    
    public function move_secelement_to_other() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $orig_sec_id = isset($_REQUEST['orig_sec_id']) ? $_REQUEST['orig_sec_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $element_id = isset($_REQUEST['element_id']) ? $_REQUEST['element_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->move_elem_to_othersec($menu_id, $orig_sec_id, $section_id, $element_id, $builder_type);
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function sort_dashb_menu_itms() {
        $response = array();
        
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->sorting_menu_mitms($builder_type, $_REQUEST);
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function sort_menu_sections() {
        $response = array();
        
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->sorting_menu_sects($menu_id, $builder_type, $_REQUEST);
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function sort_section_elements() {
        $response = array();
        
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->sorting_sect_elements($menu_id, $section_id, $builder_type, $_REQUEST);
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function sort_element_fields() {
        $response = array();
        
        $element_id = isset($_REQUEST['element_id']) ? $_REQUEST['element_id'] : '';
        $section_id = isset($_REQUEST['section_id']) ? $_REQUEST['section_id'] : '';
        $menu_id = isset($_REQUEST['menu_id']) ? $_REQUEST['menu_id'] : '';
        $builder_type = isset($_REQUEST['builder_type']) ? $_REQUEST['builder_type'] : '';
        
        $common_functions = new Common_Functions;
        
        $common_functions->sorting_element_fields($menu_id, $section_id, $element_id, $builder_type, $_REQUEST);
        $response['status'] = 'success';

        wp_send_json($response);
    }
    
    public function create_menu_slug() {
        $common_functions = new Common_Functions;
        
        $common_functions->generate_menu_slug($_REQUEST);
    }

}

new Rest_APIs;
