<?php

use FoodSearch\Common_Functions;
use FoodSearch\user_orders as FoodSearch_Orders;

if (isset($_GET['order_id']) && $_GET['order_id'] > 0) {
    global $wpdb, $table_prefix;
    $order_id = $_GET['order_id'];
    $table_name = $table_prefix . 'fds_orders';
    $order_result = $wpdb->get_row("SELECT * FROM $table_name WHERE order_id=$order_id", 'ARRAY_A');
}
if (isset($order_result) && !empty($order_result)) {

    global $foodsearch_user_orders_obj;
    
    $foodsearch_orders = new FoodSearch_Orders;

    $order_meta = FoodSearch_Orders::get_order_meta($order_id);
    $first_name = FoodSearch_Orders::order_meta_value($order_meta, 'billing_first_name');
    $last_name = FoodSearch_Orders::order_meta_value($order_meta, 'billing_last_name');
    $billing_email = FoodSearch_Orders::order_meta_value($order_meta, 'billing_email');
    $billing_phone = FoodSearch_Orders::order_meta_value($order_meta, 'billing_phone');
    $billing_address = FoodSearch_Orders::order_meta_value($order_meta, 'billing_address');

    $order_title = 'Order #' . $order_id;
    if ($first_name != '' && $last_name != '') {
        $order_title .= " ($first_name $last_name)";
    }
    
    $order_status = $order_result['status'];

    $status_list = FoodSearch_Orders::get_order_statuses();
    $paym_list = $foodsearch_user_orders_obj->get_order_paymethods();

    $pay_method = FoodSearch_Orders::order_meta_value($order_meta, 'payment_method');
    $pay_method_label = $foodsearch_user_orders_obj->get_order_paymethod_label($pay_method);

    $create_date = $order_result['date_created'];
    $create_date_formate = date_i18n(get_option('date_format'), strtotime($create_date)) . ' @ ' . date_i18n(get_option('time_format'), strtotime($create_date));
    ?>
    <div class="wrap">
        <h1 class="wp-heading-inline fds-heading-title"><?php esc_html_e('edit order', 'wp-foodsearch'); ?></h1>
        <hr class="wp-header-end">
        <?php
        if (isset($_POST['foodsearch_order_modify'])) {
            ?>
            <div class="updated">
                <p><?php esc_html_e('order updated successfully.', 'wp-foodsearch'); ?></p>
            </div>
            <?php
        }
        ?>
        <form id="post" method="post" name="post">
            <?php wp_nonce_field('foodsearch-plugin-orderupdate') ?>
            <input type="hidden" name="order_id" value="<?php echo ($order_id) ?>">
            <input type="hidden" name="foodsearch_order_modify" value="1">
            <div id="poststuff">
                <div id="post-body" class="metabox-holder columns-2">
                    <div id="postbox-container-1" class="postbox-container">
                        <div id="side-sortables" class="meta-box-sortables ui-sortable">
                            <div class="postbox">
                                <div class="postbox-header">
                                    <h2 class="hndle ui-sortable-handle fds-heading-title"><?php esc_html_e('order actions', 'wp-foodsearch'); ?></h2>
                                </div>
                                <div class="inside">
                                    <ul class="order_actions submitbox fds-options-wrap">
                                        <li class="wide fds-list-item">
                                            <button type="submit" class="button save_order button-primary" name="save"><?php esc_html_e('update', 'wp-foodsearch'); ?></button>
                                        </li>
                                    </ul>
                                    <?php
                                    $order_status_notes = FoodSearch_Orders::order_meta_value($order_meta, 'status_notes');
                                    $order_status_notes = $order_status_notes != '' ? maybe_unserialize($order_status_notes) : '';
                                    if (!empty($order_status_notes) && is_array($order_status_notes)) {
                                        ?>
                                        <div class="fds-order-notes">
                                            <?php
                                            uasort($order_status_notes, function ($a, $b) {
                                                if ($a['time'] == $b['time']) {
                                                    $ret_val = 0;
                                                }
                                                $ret_val = ($b['sort'] < $a['sort']) ? -1 : 1;
                                                return $ret_val;
                                            });

                                            $order_status_hislist = array_slice($order_status_notes, 0, 10);

                                            foreach ($order_status_hislist as $status_note) {
                                                $ustatus_note = $status_note['note'];
                                                $ustatus_time = $status_note['time'];
                                                $ustatus_user = $status_note['user'];
                                                ?>
                                                <div class="order-note-item">
                                                    <p class="note-txt"><?php echo ($ustatus_note) ?></p>
                                                    <?php
                                                    if ($ustatus_time > 0) {
                                                        $note_date = date_i18n(get_option('date_format'), $ustatus_time);
                                                        $note_time = date_i18n(get_option('time_format'), $ustatus_time);
                                                        
                                                        $note_owner_name = '';
                                                        if ($ustatus_user > 0) {
                                                            $note_user = get_user_by('id', $ustatus_user);
                                                            if (isset($note_user->display_name)) {
                                                                $note_owner_name = $note_user->display_name;
                                                            }
                                                        }
                                                        ?>
                                                        <span class="note-datetime"><?php echo ($note_date . ' @ ' . $note_time) ?><?php echo ($note_owner_name != '' ? '&nbsp;' . sprintf(esc_html__('by %s', 'wp-foodsearch'), $note_owner_name) : '') ?></span>
                                                        <?php
                                                    }
                                                    ?>
                                                </div>
                                                <?php
                                            }
                                            ?>
                                        </div>
                                        <?php
                                    }
                                    ?>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="postbox-container-2" class="postbox-container">
                        <div id="normal-sortables" class="meta-box-sortables ui-sortable">
                            <div class="postbox">
                                <div class="fds-order-bkcon">
                                    <div class="fds-order-tophder">
                                        <h2 class="order-heding fds-heading-title"><?php echo ($order_title) ?></h2>
                                        <p class="order-method-desc"><?php printf(esc_html__('payment via %s.', 'wp-foodsearch'), $pay_method_label); ?></p>
                                    </div>
                                    <div class="fds-order-subdetail">
                                        <div class="fds-order-subditm fds-order-generaldetail">
                                            <div class="detal-heding"><h3><?php esc_html_e('general', 'wp-foodsearch'); ?></h3></div>
                                            <div class="order-info-field-item">
                                                <span class="field-label"><?php printf(esc_html__('date created: %s', 'wp-foodsearch'), $create_date_formate); ?></span>
                                            </div>
                                            <div class="fds-form-field select-field-con fds-select-field">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('status:', 'wp-foodsearch'); ?></label></div>
                                                <select name="order_status" class="select_dropdown" data-placeholder="<?php esc_html_e('select order status', 'wp-foodsearch'); ?>">
                                                    <option value=""><?php esc_html_e('select order status', 'wp-foodsearch') ?></option>
                                                    <?php
                                                    foreach ($status_list as $status_key => $status_label) {
                                                        if ($status_key == 'trash') {
                                                            continue;
                                                        }
                                                        $selcted_status = $status_key == $order_status ? ' selected' : '';
                                                        ?>
                                                        <option value="<?php echo ($status_key) ?>"<?php echo ($selcted_status) ?>><?php echo ($status_label) ?></option>
                                                        <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="fds-order-subditm fds-order-bilingdetail">
                                            <div class="detal-heding"><h3><?php esc_html_e('billing', 'wp-foodsearch'); ?></h3></div>
                                            <div class="fds-form-field">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('first name', 'wp-foodsearch'); ?></label></div>
                                                <input type="text" name="order_billing[first_name]" class="fds-input-style" value="<?php echo ($first_name) ?>" required="">
                                            </div>
                                            <div class="fds-form-field">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('last name', 'wp-foodsearch'); ?></label></div>
                                                <input type="text" name="order_billing[last_name]" class="fds-input-style" value="<?php echo ($last_name) ?>" required="">
                                            </div>
                                            <div class="fds-form-field">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('email', 'wp-foodsearch'); ?></label></div>
                                                <input type="text" name="order_billing[email]" class="fds-input-style" value="<?php echo ($billing_email) ?>" required="">
                                            </div>
                                            <div class="fds-form-field">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('phone', 'wp-foodsearch'); ?></label></div>
                                                <input type="text" name="order_billing[phone]" class="fds-input-style" value="<?php echo ($billing_phone) ?>" required="">
                                            </div>
                                            <div class="fds-form-field">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('address', 'wp-foodsearch'); ?></label></div>
                                                <input type="text" name="order_billing[address]" class="fds-input-style" value="<?php echo ($billing_address) ?>" required="">
                                            </div>
                                            <div class="fds-form-field select-field-con">
                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('payment method', 'wp-foodsearch'); ?></label></div>
                                                <select name="payment_method" class="select_dropdown fds-select-field" data-placeholder="<?php esc_html_e('select payment method', 'wp-foodsearch'); ?>" required="">
                                                    <option value=""><?php esc_html_e('select payment method', 'wp-foodsearch'); ?></option>
                                                    <?php
                                                    foreach ($paym_list as $paym_key => $paym_label) {
                                                        $selcted_method = $paym_key == $pay_method ? ' selected' : '';
                                                        ?>
                                                        <option value="<?php echo ($paym_key) ?>"<?php echo ($selcted_method) ?>><?php echo ($paym_label) ?></option>
                                                        <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <?php
                            $order_items = $foodsearch_orders->get_order_items($order_id, 'menu_items');
                            if (!empty($order_items)) {
                                
                                $order_subtotal = $order_result['total_sales'];
                                $order_net_total = $order_result['net_total'];
                                ?>
                                <div id="fds-order-items-list" class="postbox">
                                    <div class="inside orderdet-items-inside">
                                        <div class="fds-table-items-wrapper">
                                            <ul class="fds-table-item-row item-row-heder fds-options-wrap">
                                                <li class="table-item-heditm itm-name fds-list-item"><?php esc_html_e('item', 'wp-foodsearch'); ?></li>
                                                <li class="table-item-heditm itm-cost fds-list-item"><?php esc_html_e('cost', 'wp-foodsearch'); ?></li>
                                                <li class="table-item-heditm itm-qty fds-list-item"><?php esc_html_e('qty', 'wp-foodsearch'); ?></li>
                                                <li class="table-item-heditm itm-totl fds-list-item"><?php esc_html_e('total', 'wp-foodsearch'); ?></li>
                                            </ul>
                                            <?php
                                            $items_counter = 1;
                                            $total_order_items = count($order_items);
                                            $menu_itms_open = false;
                                            foreach ($order_items as $order_item) {
                                                $order_item_id = $order_item['order_item_id'];
                                                $order_item_name = $order_item['order_item_name'];
                                                $order_item_type = $order_item['order_item_type'];
                                                if ($order_item_type == 'menu_item' || $order_item_type == 'menu_item_extra') {
                                                    $order_item_meta = $foodsearch_orders->get_order_item_meta($order_item_id);
                                                    $item_menu_id = $foodsearch_orders->order_item_meta_value($order_item_meta, 'menu_id');
                                                    $item_qty = $foodsearch_orders->order_item_meta_value($order_item_meta, 'qty');
                                                    $item_subtotal = $foodsearch_orders->order_item_meta_value($order_item_meta, 'subtotal');

                                                    $table_name = $table_prefix . 'menu_items';
                                                    $menu_itmsql = "SELECT * FROM $table_name WHERE id=$item_menu_id";
                                                    $menu_itm_obj = $wpdb->get_row($menu_itmsql);

                                                    $image_src = '';
                                                    $image_id = $menu_itm_obj->attachment_id;
                                                    if ($image_id > 0) {
                                                        $image_thumb = wp_get_attachment_image_src($image_id);
                                                        $image_src = isset($image_thumb[0]) ? $image_thumb[0] : '';
                                                    }
                                                    $menu_itm_label = $menu_itm_obj->name;

                                                    $item_alltotal = $item_subtotal * $item_qty;

                                                    if ($items_counter > 1) {
                                                        if ($order_item_type == 'menu_item_extra' && $menu_itms_open === false) {
                                                            echo '<div class="fds-table-list-items active-list-itms items-con-' . $rand_num . '">';
                                                            $menu_itms_open = true;
                                                        } else if ($order_item_type == 'menu_item' && $menu_itms_open === false) {
                                                            $rand_num = rand(1000000, 9999999);
                                                            echo '<div class="fds-item-table-list fds-to-list-itms" data-id="' . $rand_num . '">';
                                                        } else if ($order_item_type == 'menu_item' && $menu_itms_open === true) {
                                                            $rand_num = rand(1000000, 9999999);
                                                            $menu_itms_open = false;
                                                            echo '</div><div class="fds-item-table-list fds-to-list-itms" data-id="' . $rand_num . '">';
                                                        }
                                                    } else {
                                                        $rand_num = rand(1000000, 9999999);
                                                        echo '<div class="fds-item-table-list fds-to-list-itms" data-id="' . $rand_num . '">';
                                                    }
                                                    ?>
                                                    <ul class="fds-order-item-row fds-options-wrap">
                                                        <li class="table-item-cell itm-name fds-list-item">
                                                            <img src="<?php echo ($image_src) ?>" class="order-itm-thumbnail" alt="">
                                                            <span class="order-name"><?php echo ($menu_itm_label) ?></span>
                                                        </li>
                                                        <li class="table-item-cell itm-cost fds-list-item">
                                                            <span class="order-itm-amount"><?php echo (Common_Functions::get_formatted_price($item_subtotal)) ?></span>
                                                        </li>
                                                        <li class="table-item-cell itm-qty fds-list-item">
                                                            <small class="times">x</small> <?php echo ($item_qty) ?>
                                                        </li>
                                                        <li class="table-item-cell itm-totl fds-list-item">
                                                            <span class="order-itm-total"><?php echo (Common_Functions::get_formatted_price($item_alltotal)) ?></span>
                                                        </li>
                                                    </ul>
                                                    <?php
                                                    if ($items_counter > 1) {
                                                        if ($items_counter == $total_order_items && $menu_itms_open === true) {
                                                            echo '</div>';
                                                        }
                                                        if ($order_item_type == 'menu_item') {
                                                            echo '</div>';
                                                        }
                                                    } else {
                                                        echo '</div>';
                                                    }
                                                    $items_counter++;
                                                }
                                            }
                                            ?>
                                        </div>
                                        <div class="fds-order-totals-items">
                                            <ul class="fds-total-itmscon fds-options-wrap">
                                                <li class="ordrtotl-label fds-list-item"><?php esc_html_e('items subtotal:', 'wp-foodsearch'); ?></li>
                                                <li class="fds-list-item">
                                                    <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($order_subtotal)) ?></span>
                                                </li>
                                            </ul>
                                            <?php
                                            $delivery_fee = isset($order_result['shipping_total']) ? $order_result['shipping_total'] : '';
                                            if ($delivery_fee > 0) {
                                                ?>
                                                <ul class="fds-total-itmscon fds-options-wrap">
                                                    <li class="ordrtotl-label fds-list-item"><?php esc_html_e('delivery charges:', 'wp-foodsearch'); ?></li>
                                                    <li class="fds-list-item">
                                                        <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($delivery_fee)) ?></span>
                                                    </li>
                                                </ul>
                                                <?php
                                            }

                                            $order_vat_switch = isset($foodsearch_plugin_settings['payment_settings']['order_vat_tax']) ? $foodsearch_plugin_settings['payment_settings']['order_vat_tax'] : '';

                                            $order_tax_amount = isset($order_result['tax_total']) ? $order_result['tax_total'] : '';

                                            $vat_amount = 0;
                                            if ($order_tax_amount > 0) {
                                                $vat_amount = $order_tax_amount;
                                            }
                                            if ($vat_amount > 0 || $order_vat_switch == 'on') {
                                                ?>
                                                <ul class="fds-total-itmscon fds-options-wrap">
                                                    <li class="ordrtotl-label fds-list-item"><?php esc_html_e('vat:', 'wp-foodsearch'); ?></li>
                                                    <li class="fds-list-item">
                                                        <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($vat_amount)) ?></span>
                                                    </li>
                                                </ul>
                                                <?php
                                            }
                                            ?>
                                            <ul class="fds-total-itmscon fds-options-wrap">
                                                <li class="ordrtotl-label fds-list-item"><?php esc_html_e('order total:', 'wp-foodsearch'); ?></li>
                                                <li class="fds-list-item">
                                                    <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($order_net_total)) ?></span>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                                <?php
                            }
                            ?>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
    <?php
} else {
    ?>
    <div class="page-wrapper">
        <!-- Page-body start -->
        <div class="page-body">
            <!-- Table header styling table start -->
            <div class="das-card wrap">
                <div class="das-card-header">
                    <h5><?php echo esc_html__('orders', 'wp-foodsearch'); ?></h5>
                </div>
                <div class="das-card-block table-border-style">
                    <div class="clearfix"></div>
                    <?php
                    require dirname(dirname(__FILE__)) . '/admin-tables/orders-table.php';
                    $registration = new Foodsearch_Orders_Table;
                    echo '<form method="post">';
                    $data = $registration->prepare_items();
                    $registration->views();
                    $srch_title = esc_html__('search records', 'wp-foodsearch');
                    $registration->search_box($srch_title, 'search_record');
                    $registration->display();
                    echo '</form>';
                    ?>
                </div>
                <?php
            }