var foodsearch__map;
var foodsearch_map_markers = [];

jQuery(document).ready(function() {

    function foodsearch__map_render() {
        "use strict";
        if (jQuery('.fds-location-map-outer').length > 0) {
            var map_parent_con = jQuery('.fds-location-map-outer');
            var rand_id = map_parent_con.attr('data-id');
            
            var def_lat = parseFloat(google_map_vars.lat);
            var def_lng = parseFloat(google_map_vars.lng);
            
            var map_lat_lng = {lat: def_lat, lng: def_lng};
            foodsearch__map = new google.maps.Map(document.getElementById('fds-map-' + rand_id), {
                zoom: parseInt(google_map_vars.zoom),
                center: map_lat_lng,
                streetViewControl: false,
                scrollwheel: false,
                mapTypeControl: false,
            });
            
            var marker = new google.maps.Marker({
                position: map_lat_lng,
                map: foodsearch__map,
                draggable: true,
            });
            
            foodsearch_map_markers.push(marker);

            google.maps.event.addListener(marker, 'dragend', function () {
                document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
            });
            google.maps.event.addListener(foodsearch__map, 'zoom_changed', function () {
                var zoom_lvl = foodsearch__map.getZoom();
                document.querySelector('.fds-map-zoom-field').value = zoom_lvl;
            });
            
            var autocomplete_input = document.querySelector('.fds-loc-address-field');
            var autcomplete_options = {};
            var autocomplete = new google.maps.places.Autocomplete(autocomplete_input, autcomplete_options);
            
            google.maps.event.addListener(autocomplete, 'place_changed', function () {
                var geocode_did_work = false;
                var geti_ayuto_adres = autocomplete.getPlace().formatted_address;
                var geocoder = new google.maps.Geocoder();
                geocoder.geocode({address: geti_ayuto_adres}, function (results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        geocode_did_work = true;
                        var new_latitude = results[0].geometry.location.lat();
                        var new_longitude = results[0].geometry.location.lng();
                        
                        document.querySelector('.fds-map-lat-field').value = new_latitude;
                        document.querySelector('.fds-map-lng-field').value = new_longitude;
                        
                        // clear previous markers
                        for (var i = 0; i < foodsearch_map_markers.length; i++) {
                            foodsearch_map_markers[i].setMap(null);
                        }
                        
                        var marker = new google.maps.Marker({
                            map: foodsearch__map,
                            position: results[0].geometry.location,
                            draggable: true,
                        });
                        foodsearch_map_markers.push(marker);
                        
                        google.maps.event.addListener(marker, 'dragend', function () {
                            document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                            document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                            foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
                        });
                    }
                });
                if (geocode_did_work === false) {
                    var mapbox_access_token = google_map_vars.mapbox_access_token;
                    if (mapbox_access_token != '') {
                        var map_addrapi_uri = 'https://api.mapbox.com/geocoding/v5/mapbox.places/' + encodeURI(geti_ayuto_adres) + '.json?access_token=' + mapbox_access_token;
                        foodsearch_common_getJSON(map_addrapi_uri, function (loc_status, new_loc_response) {
                            if (typeof new_loc_response === 'object') {
                                var new_cords = new_loc_response.features[0].geometry.coordinates;
                                if (new_cords !== 'undefined') {
                                    var new_latitude = new_cords[1];
                                    var new_longitude = new_cords[0];
                                    
                                    var new_position = {lat: new_latitude, lng: new_longitude};

                                    document.querySelector('.fds-map-lat-field').value = new_latitude;
                                    document.querySelector('.fds-map-lng-field').value = new_longitude;
                                    
                                    foodsearch__map.setCenter(new_position);

                                    // clear previous markers
                                    for (var i = 0; i < foodsearch_map_markers.length; i++) {
                                        foodsearch_map_markers[i].setMap(null);
                                    }

                                    var marker = new google.maps.Marker({
                                        map: foodsearch__map,
                                        position: new_position,
                                        draggable: true,
                                    });
                                    foodsearch_map_markers.push(marker);

                                    google.maps.event.addListener(marker, 'dragend', function () {
                                        document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                                        document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                                        foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
                                    });
                                }
                            }
                        });
                    }
                }
            });
        }
    }
    
    foodsearch__map_render();
});