var foodsearch__map;
var foodsearch_map_markers = [];

jQuery(document).ready(function() {
    
    function foodsearch__map_render() {
        "use strict";
        if (jQuery('.fds-location-map-outer').length > 0 && mapbox_loc_vars.api_key != '' && mapbox_loc_vars.map_style != '') {
            var map_parent_con = jQuery('.fds-location-map-outer');
            var rand_id = map_parent_con.attr('data-id');
            var def_lat = parseFloat(mapbox_loc_vars.lat);
            var def_lng = parseFloat(mapbox_loc_vars.lng);
            
            var map_center_cords = [def_lng, def_lat];
            
            mapboxgl.accessToken = mapbox_loc_vars.api_key;
            foodsearch__map = new mapboxgl.Map({
                container: 'fds-map-' + rand_id,
                style: mapbox_loc_vars.map_style,
                center: map_center_cords,
                scrollZoom: false,
                zoom: mapbox_loc_vars.zoom
            });
            
            foodsearch_map_markers = [];
            var geocoder_params = {
                accessToken: mapboxgl.accessToken,
                mapboxgl: mapboxgl,
                marker: false,
                placeholder: mapbox_loc_vars.search_placeholder
            };
            var selected_contries = mapbox_loc_vars.def_countries;
            if (selected_contries != '') {
                var selected_contries_tojs = JSON.parse(selected_contries);
                var sel_countries_str = selected_contries_tojs.join();
                geocoder_params['countries'] = sel_countries_str;
            }

            var geocoder = new MapboxGeocoder(geocoder_params);

            document.querySelector('.fds-mapbox-loc-geocoder').appendChild(geocoder.onAdd(foodsearch__map));

            geocoder.on('result', function(obj) {
                var place_name = obj.result.place_name;
                var map_center_coords = obj.result.geometry.coordinates;
                if (map_center_coords.length > 1) {
                    var map_center_lng = map_center_coords[0];
                    var map_center_lat = map_center_coords[1];
                    document.querySelector('.fds-loc-address-field').value = place_name;
                    document.querySelector('.fds-map-lat-field').value = map_center_lat;
                    document.querySelector('.fds-map-lng-field').value = map_center_lng;
                    // remove markers 
                    if (foodsearch_map_markers !== null) {
                        for (var i = foodsearch_map_markers.length - 1; i >= 0; i--) {
                            foodsearch_map_markers[i].remove();
                        }
                    }
                    //
                    var new_marker = new mapboxgl.Marker({
                        draggable: true
                    }).setLngLat(map_center_coords).addTo(foodsearch__map);
                    foodsearch_map_markers.push(new_marker);
                    new_marker.on('dragend', function () {
                        var lngLat = new_marker.getLngLat();
                        document.querySelector('.fds-map-lat-field').value = lngLat.lat;
                        document.querySelector('.fds-map-lng-field').value = lngLat.lng;
                        foodsearch_get_map_cords_addres(lngLat.lat, lngLat.lng);
                    });
                }
            });
            //
            foodsearch__map.addControl(new mapboxgl.NavigationControl({
                showCompass: false    
            }), 'top-right');
            var marker = new mapboxgl.Marker({
                draggable: true
            }).setLngLat(map_center_cords).addTo(foodsearch__map);
            foodsearch_map_markers.push(marker);
            function onDragEnd() {
                var lngLat = marker.getLngLat();
                document.querySelector('.fds-map-lat-field').value = lngLat.lat;
                document.querySelector('.fds-map-lng-field').value = lngLat.lng;
                foodsearch_get_map_cords_addres(lngLat.lat, lngLat.lng);
            }
            marker.on('dragend', onDragEnd);
            function onZoomMap(objZoom) {
                if (typeof objZoom.target._easeOptions.zoom !== 'undefined') {
                    var getZoomLvel = objZoom.target._easeOptions.zoom;
                    document.querySelector('.fds-map-zoom-field').value = getZoomLvel;
                }
            }
            foodsearch__map.on('zoom', onZoomMap);
        }
    }
    
    foodsearch__map_render();
    
    if (jQuery('.fds-mapbox-loc-geocoder').length > 0) {
        var map_geocoder_intrval = setInterval(function() {
            var map_geocodr_con = jQuery('.fds-mapbox-loc-geocoder');
            if (!map_geocodr_con.find('input[type=text]').hasClass('fds-loc-address-field')) {
                map_geocodr_con.find('input[type=text]').addClass('fds-input-style fds-loc-address-field').attr('name', 'fds_loc_address');
                if (map_geocodr_con.parents('.fds-address-fields').hasClass('adres-fields-open')) {
                    map_geocodr_con.find('input[type=text]').attr('required', '');
                }
                clearInterval(map_geocoder_intrval);
            }
        }, 1000);
    }
    
    if (jQuery('.fds-location-map-outer').length > 0) {
        var map_outervisib_intrval = setInterval(function() {
            var map_parent_con = jQuery('.fds-location-map-outer');
            if (map_parent_con.hasClass('fds-outer-visible')) {
                foodsearch__map.resize();
                map_parent_con.removeClass('fds-outer-visible')
                clearInterval(map_outervisib_intrval);
            }
        }, 500);
    }
});