<?php

namespace FoodSearch\Dashboard\Common;
use FoodSearch\Common_Functions as General_Functions;

class Account_Switcher {
    
    public function __construct() {
        
        add_filter('foodsearch_restaurant_dash_acc_switcher_html', [$this, 'content'], 10, 4);
        add_filter('foodsearch_customer_dash_acc_switcher_html', [$this, 'content'], 10, 4);
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {

        $common_functions = new General_Functions;
        $user_id = get_current_user_id();
        $user_type = General_Functions::user_type($user_id);
        if ($user_type == 'restaurant') {
            $acc_type = 'restaurant';
        } else {
            $acc_type = 'customer';
        }
        ob_start();
        ?>
        <div class="choose-userdash-type">
            <div class="choose-usertype-box">
                <a href="javascript:void(0);" data-utyp="restaurant" data-nid="<?php echo ($user_id) ?>" class="fds-switch-acountbtn fds-link">
                    <span class="usertype-img-box">
                        <img src="<?php echo foodsearch_plugin_get_url('assets/images/box-svg1.svg') ?>" alt="">
                    </span>
                    <?php esc_html_e('i am restaurant', 'wp-foodsearch') ?>
                </a>
            </div>
            <div class="choose-usertype-box">
                <a href="javascript:void(0);" data-utyp="customer" data-nid="<?php echo ($user_id) ?>" class="fds-switch-acountbtn fds-link">
                    <span class="usertype-img-box">
                        <img src="<?php echo foodsearch_plugin_get_url('assets/images/box-svg3.svg') ?>" alt="">
                    </span>
                    <?php esc_html_e('i am customer', 'wp-foodsearch') ?>
                </a>
            </div>
        </div>
        <?php
        $html = ob_get_clean();

        return $html;
    }

}

new Account_Switcher;
