<?php

namespace FoodSearch\Dashboard;

class Dash_Stats {
    
    public function __construct() {
        
        $this->includes();
        add_filter('foodsearch_user_dash_content_html', [$this, 'dashboard'], 10, 2);
    }
    
    public function includes() {
        $foodsearch_plugin_settings =  get_option('foodsearch_plugin_settings');
       // echo '<pre>'.print_r($foodsearch_plugin_settings,true).'</pre>';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/settings.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/customer/settings.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/image-upload.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/customer/image-upload.php';
        if(isset($foodsearch_plugin_settings['payment_settings']['wc_cart_active']) && $foodsearch_plugin_settings['payment_settings']['wc_cart_active']=='on' &&  class_exists( 'WooCommerce' )){
          // echo 'hi woocommerce';
             require plugin_dir_path(dirname(dirname(__FILE__))) . 'includes/classes/woocommerce/orders/restaurant.php';             
             require plugin_dir_path(dirname(dirname(__FILE__))) . 'includes/classes/woocommerce/orders/customer.php';
       }
       else{
       // echo 'hi shop';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/orders.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/customer/orders.php';
       }
       
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/menu-builder.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/nutritions.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/choice-groups.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/followings.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/customer/favourites.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/restaurant/reviews.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/customer/reviews.php';
        
        include plugin_dir_path(dirname(__FILE__)) . 'content/location-address.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/change-password.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/account-switcher.php';
        include plugin_dir_path(dirname(__FILE__)) . 'content/custom-content.php';
    }
    
    public function dashboard($html, $user_type) {
        
        ob_start();
        if ($user_type == 'restaurant') {
            echo 'this is restaurant dashboard';
        } else if ($user_type == 'customer') {
            echo 'this is customer dashboard';
        }
        $html = ob_get_clean();
        
        return $html;
    }

}

new Dash_Stats;
