<?php

namespace FoodSearch\Dashboard\Restaurant;
use FoodSearch\Common_Functions;

class Choice_Groups {
    
    public function __construct() {
        
        add_action('wp_enqueue_scripts', [$this, 'style_scripts']);
        
        add_filter('foodsearch_restaurant_dash_choice_groups_html', [$this, 'content'], 10, 4);
    }
    
    public function style_scripts() {
        
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        wp_enqueue_script('jquery-ui-sortable');
        wp_enqueue_script('jquery-ui-widget');
        wp_enqueue_script('jquery-ui-mouse');
        wp_enqueue_script('jquery-ui-accordion');
        wp_enqueue_script('jquery-ui-autocomplete');
        wp_enqueue_script('jquery-ui-slider');
        
        wp_enqueue_script('menu_builder_front');
        
        $user_id = get_current_user_id();
        
        $common_functions = new Common_Functions;
        
        $restaurant_id = Common_Functions::user_restaurant_id($user_id);
        ob_start();
        ?>
        <div class="fds-dash-add-choicegroups">
            <div class="all-choice-groups-con fds-recet-order-list" data-restaurant="<?php echo ($restaurant_id) ?>"></div>
            <div class="choicegroup-add-btn fds-menu-builder-empty">
                <div class="fds-btn fds-medium-btn">
                    <a href="javascript:void(0);" class="fds-add-choicegroup fds-has-bg fds-link" data-restaurant="<?php echo ($restaurant_id) ?>" data-nid="<?php echo ($user_id) ?>"><i class="fds-icon fds-writing"></i> <?php esc_html_e('add new choice group', 'wp-foodsearch'); ?></a>
                </div>
            </div>
        </div>
        <?php
        $html = ob_get_clean();
        add_action('wp_footer', function() {
            ?>
            <div id="choice-group-popup" class="fds-modal-popup fds-popup-hide fds-choicegr-modal">
                <div class="fds-modal-container">
                    <a href="javascript:void(0);" class="fds-popup-closebtn fds-link"><i class="fds-icon fds-time-simple"></i></a>
                    <div class="fds-modal-inner-area">
                        <div class="fds-modal-content-area">
                            <div class="fds-dynm-modal-content">
                                <div class="fds-loader-holder"><div class="fds-loader"></div></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <?php
        }, 20);
        
        return $html;
    }
    
    public function add_choice_group($post_data) {
        $user_id = $post_data['n_id'];
        $restaurant_id = $post_data['restaurant'];
        ob_start();
        ?>
        <div class="fds-booking-detail-title"><h2 class="fds-heading-title"><?php esc_html_e('add choice group', 'wp-foodsearch'); ?></h2></div>
        <div class="fds-builder-popupform">
            <form id="fds-addchoicegroup-form" class="fds-update-anything-action" method="post">
                <div class="fds-popupform-inner-wrap">
                    <div class="fds-choicegrp-fields-wrap">
                        <input type="hidden" name="restaurant_id" value="<?php echo ($restaurant_id) ?>">
                        <div class="fds-form-field">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('title *', 'wp-foodsearch'); ?></label></div>
                            <input type="text" name="name" class="fds-input-style" required="">
                        </div>
                        <div class="fds-form-field select-field-con">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('minimum number of choices *', 'wp-foodsearch'); ?></label></div>
                            <div class="fds-select-field">
                                <select id="min_dropdown" name="min" data-placeholder="<?php esc_html_e('select minimum number of choices', 'wp-foodsearch') ?>" class="select_menu post-filed select_dropdown min_dropdown" required="">
                                    <option value=""><?php esc_html_e('select minimum number of choices', 'wp-foodsearch'); ?></option>
                                    <option value="0">0</option>
                                    <option value="1">1</option>
                                </select>
                            </div>
                            <span class="fds-field-desc"><?php esc_html_e('enter \'0\' if this group is optional for your customers', 'wp-foodsearch'); ?></span>
                        </div>
                        <div class="fds-form-field select-field-con">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('maximum number of choices', 'wp-foodsearch'); ?></label></div>
                            <div class="fds-select-field">
                                <select id="max_dropdown" name="max" data-placeholder="<?php esc_html_e('select maximum number of choices', 'wp-foodsearch') ?>" class="select_menu post-filed select_dropdown max_dropdown">
                                    <option value=""><?php esc_html_e('select maximum number of choices', 'wp-foodsearch'); ?></option>
                                    <option value="1">1</option>
                                </select>
                            </div>
                            <span class="fds-field-desc"><?php esc_html_e('enter \'1\' if your customers can only choose 1', 'wp-foodsearch'); ?></span>
                        </div>
                        <div class="fds-product_choices fds-menu-builder-list">
                            <div class="fds-filed-group">
                                <div class="field_wrapper_outer">
                                    <div class="field_wrapper">
                                        <div class="item_box">
                                            <div id="fooditemFiled">
                                                <div class="food-items-conder">
                                                    <div class="fds-form-field select-field-con">
                                                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('select food item', 'wp-foodsearch'); ?></label></div>
                                                        <div class="fds-select-field fds-multi-select">
                                                            <select name="item_id[]" data-placeholder="<?php esc_html_e('select food item', 'wp-foodsearch') ?>" class="select_menu post-filed food-item-dropdown">
                                                                <option value=""><?php esc_html_e('select food item', 'wp-foodsearch'); ?></option>
                                                            </select>
                                                        </div>
                                                    </div>
                                                    <div class="fds-form-field">
                                                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('price', 'wp-foodsearch'); ?></label></div>
                                                        <input type="number" step='0.01' name="item_price[]" class="fds-input-style">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <a href="javascript:void(0);" class="fds-add-action add_button fds-link" title="<?php esc_html_e('add field', 'wp-foodsearch') ?>"><?php esc_html_e('+ add food item', 'wp-foodsearch') ?></a>
                                </div>
                            </div>
                        </div>
                        <div class="fds-loader-holder" style="display: none;"></div>
                    </div>
                </div>
                <div class="fds-form-submitcon fds-add-newcat">
                    <?php wp_nonce_field('choice_group', 'choice_group_nonce'); ?>
                    <div class="fds-btn fds-medium-btn">
                        <button type="submit" class="fds-newcat-savebtn fds-has-bg"><?php esc_html_e('add choice group', 'wp-foodsearch') ?></button>
                    </div>
                </div>
            </form>
        </div>
        <?php
        $html = ob_get_clean();
        wp_send_json(array('html' => $html));
    }
    
    public function update_choice_group($post_data) {
        $choice_group_id = $post_data['n_id'];
        $restaurant_id = $post_data['restaurant'];
        
        $where = ' WHERE id=' . $choice_group_id;
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_choice_group';

        $result = $wpdb->get_row("SELECT * FROM $table_name$where");

        if (isset($result->name)) {
            
            $choice_title = $result->name;
            
            $minimum_num = $result->min;
            $maximum_num = $result->max;
            
            $variations = json_decode($result->menuItem_id, true);
            $optionCOunt = count($variations);
            for ($i = 1; $i <= $optionCOunt; $i++) {
                $option[$i] = $i;
            }
            $min_val = $option;
            $min_val[0] = 0;
            sort($min_val);
            
            ob_start();
            ?>
            <div class="fds-booking-detail-title"><h2 class="fds-heading-title"><?php esc_html_e('update choice group', 'wp-foodsearch'); ?></h2></div>
            <div class="fds-builder-popupform">
                <form id="fds-updatechoicegroup-form" class="fds-update-anything-action" method="post">
                    <div class="fds-popupform-inner-wrap">
                        <div class="fds-choicegrp-fields-wrap">
                            <input type="hidden" name="restaurant_id" value="<?php echo ($restaurant_id) ?>">
                            <input type="hidden" name="id" value="<?php echo ($choice_group_id) ?>">
                            <div class="fds-form-field">
                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('title *', 'wp-foodsearch'); ?></label></div>
                                <input type="text" name="name" value="<?php echo ($choice_title) ?>" class="fds-input-style" required="">
                            </div>
                            <div class="fds-form-field select-field-con">
                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('minimum number of choices *', 'wp-foodsearch'); ?></label></div>
                                <div class="fds-select-field">
                                    <select id="min_dropdown" name="min" class="select_menu post-filed select_dropdown min_dropdown" data-placeholder="<?php esc_html_e('select minimum number of choices', 'wp-foodsearch') ?>" required="">
                                        <option value=""><?php esc_html_e('select minimum number of choices', 'wp-foodsearch'); ?></option>
                                        <?php
                                        foreach ($min_val as $min_itm) {
                                            $selected = '';
                                            if ($minimum_num == $min_itm) {
                                                $selected = ' selected';
                                            }
                                            ?>
                                            <option value="<?php echo ($min_itm) ?>"<?php echo ($selected) ?>><?php echo ($min_itm) ?></option>
                                            <?php
                                        }
                                        ?>
                                    </select>
                                </div>
                                <span class="fds-field-desc"><?php esc_html_e('enter \'0\' if this group is optional for your customers', 'wp-foodsearch'); ?></span>
                            </div>
                            <div class="fds-form-field select-field-con">
                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('maximum number of choices', 'wp-foodsearch'); ?></label></div>
                                <div class="fds-select-field">
                                    <select id="max_dropdown" name="max" data-placeholder="<?php esc_html_e('select maximum number of choices', 'wp-foodsearch') ?>" class="select_menu post-filed select_dropdown max_dropdown">
                                        <option value=""><?php esc_html_e('select maximum number of choices', 'wp-foodsearch'); ?></option>
                                        <?php
                                        foreach ($option as $max_itm) {
                                            $selected = '';
                                            if ($maximum_num == $max_itm) {
                                                $selected = ' selected';
                                            }
                                            ?>
                                            <option value="<?php echo ($max_itm) ?>"<?php echo ($selected) ?>><?php echo ($max_itm) ?></option>
                                            <?php
                                        }
                                        ?>
                                    </select>
                                </div>
                                <span class="fds-field-desc"><?php esc_html_e('enter \'1\' if your customers can only choose 1', 'wp-foodsearch'); ?></span>
                            </div>
                            <?php
                            if (!empty($result->menuItem_id) && $optionCOunt > 0) {
                                ?>
                                <div class="fds-product_choices fds-menu-builder-list">
                                    <div class="fds-filed-group">
                                        <div class="field_wrapper_outer">
                                            <div class="field_wrapper">
                                                <?php
                                                $m = 1;
                                                foreach ($variations as $key => $val) {
                                                    $values = self::menuItemListIncId($val['item_id']);
                                                    ?>
                                                    <div class="item_box">
                                                        <?php
                                                        if ($m == 1) {
                                                            echo '<div id="fooditemFiled">';
                                                        }
                                                        ?>
                                                        <div class="food-items-conder">
                                                            <div class="fds-form-field select-field-con">
                                                                <div class="label_wrap">
                                                                    <label class="fds-input-label"><?php esc_html_e('select food item', 'wp-foodsearch'); ?></label>
                                                                    <?php
                                                                    if ($m > 1) {
                                                                        echo '<a href="javascript:void(0);" class="remove_button fds-link"><i class="dashicons-before dashicons-trash"></i></a>';
                                                                    }
                                                                    ?>
                                                                </div>
                                                                <div class="fds-select-field fds-multi-select">
                                                                    <select name="item_id[]" data-placeholder="<?php esc_html_e('select food item', 'wp-foodsearch') ?>" class="select_menu post-filed food-item-dropdown">
                                                                        <option value=""><?php esc_html_e('select food item', 'wp-foodsearch'); ?></option>
                                                                        <?php
                                                                        foreach ($values as $variation_id => $variation_label) {
                                                                            $selected = '';
                                                                            if ($val['item_id'] == $variation_id) {
                                                                                $selected = ' selected';
                                                                            }
                                                                            ?>
                                                                            <option value="<?php echo ($variation_id) ?>"<?php echo ($selected) ?>><?php echo ($variation_label) ?></option>
                                                                            <?php
                                                                        }
                                                                        ?>
                                                                    </select>
                                                                </div>
                                                            </div>
                                                            <div class="fds-form-field">
                                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('price', 'wp-foodsearch'); ?></label></div>
                                                                <input type="number" step="0.01" name="item_price[]" class="fds-input-style" value="<?php echo ($val['item_price']) ?>">
                                                            </div>
                                                        </div>
                                                        <?php
                                                        if ($m == 1) {
                                                            echo '</div>';
                                                        }
                                                        ?>
                                                    </div>
                                                    <?php
                                                    $m++;
                                                }
                                                ?>
                                            </div>
                                            <a href="javascript:void(0);" class="fds-add-action add_button fds-link" title="<?php esc_html_e('add field', 'wp-foodsearch') ?>"><?php esc_html_e('+ add food item', 'wp-foodsearch') ?></a>
                                        </div>
                                    </div>
                                </div>
                                <?php
                            } else {
                                ?>
                                <div class="fds-product_choices fds-menu-builder-list">
                                    <div class="fds-filed-group">
                                        <div class="field_wrapper_outer">
                                            <div class="field_wrapper">
                                                <div class="item_box">
                                                    <div id="fooditemFiled">
                                                        <div class="food-items-conder">
                                                            <div class="fds-form-field select-field-con">
                                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('select food item', 'wp-foodsearch'); ?></label></div>
                                                                <div class="fds-select-field fds-multi-select">
                                                                    <select name="item_id[]" data-placeholder="<?php esc_html_e('select food item', 'wp-foodsearch') ?>" class="select_menu post-filed food-item-dropdown">
                                                                        <option value=""><?php esc_html_e('select food item', 'wp-foodsearch'); ?></option>
                                                                    </select>
                                                                </div>
                                                            </div>
                                                            <div class="fds-form-field">
                                                                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('price', 'wp-foodsearch'); ?></label></div>
                                                                <input type="number" step="0.01" name="item_price[]" class="fds-input-style">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <a href="javascript:void(0);" class="fds-add-action add_button fds-link" title="<?php esc_html_e('add field', 'wp-foodsearch') ?>"><?php esc_html_e('+ add food item', 'wp-foodsearch') ?></a>
                                        </div>
                                    </div>
                                </div>
                                <?php
                            }
                            ?>
                            <div class="fds-loader-holder" style="display: none;"></div>
                        </div>
                    </div>
                    <div class="fds-form-submitcon fds-add-newcat">
                        <?php wp_nonce_field('choice_group', 'choice_group_nonce'); ?>
                        <div class="fds-btn fds-medium-btn">
                            <button type="submit" class="fds-newcat-savebtn fds-has-bg"><?php esc_html_e('save changes', 'wp-foodsearch') ?></button>
                        </div>
                    </div>
                </form>
            </div>
            <?php
            $html = ob_get_clean();
        } else {
            ob_start();
            ?>
            <div class="foodsearch-noitm-found">
                <img src="<?php echo foodsearch_plugin_get_url('assets/images/not-found.svg') ?>" alt="">
                <p><?php esc_html_e('no choice group found.', 'wp-foodsearch') ?></p>
            </div>
            <?php
            $html = ob_get_clean();
        }
        wp_send_json(array('html' => $html));
    }
    
    public function choice_groups_list($restaurant_id) {
        $where = ' WHERE restaurant_id=' . $restaurant_id;
        if (isset($_REQUEST['q'])) {
            $where .= ' AND name like "%' . $_REQUEST['q'] . '%"';
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_choice_group';

        $results = $wpdb->get_results("SELECT * FROM $table_name$where ORDER BY id DESC limit 100");
        
        if (!empty($results)) {
            $responsedata = array();
            $responsedata['error'] = '0';
            
            ob_start();
            ?>
            <div class="fds-choicegroup-itm-hder fds-recet-order-thead">
                <div class="fds-column-title title-choice"><?php esc_html_e('title', 'wp-foodsearch'); ?></div>
                <div class="fds-column-title min-numbr"><?php esc_html_e('minimum select', 'wp-foodsearch'); ?></div>
                <div class="fds-column-title max-numbr"><?php esc_html_e('maximum select', 'wp-foodsearch'); ?></div>
                <div class="fds-column-title choice-status"><?php esc_html_e('status', 'wp-foodsearch'); ?></div>
                <div class="fds-column-title choice-actions">&nbsp;</div>
            </div>
            <?php
            foreach ($results as $row) {
                
                $choice_id = $row->id;
                
                $choice_title = $row->name;
                
                $minimum_num = $row->min;
                $maximum_num = $row->max;
                
                $status = $row->status;
                $status_text = esc_html__('pending', 'wp-foodsearch');
                $status_color = '#fdc940';
                if ($status == '2') {
                    $status_text = esc_html__('approved', 'wp-foodsearch');
                    $status_color = '#5cb85c';
                }
                ?>
                <div class="fds-choicegroup-itm fds-recet-order-tbody">
                    <div class="fds-recet-order-cell title-choice"><?php echo ($choice_title) ?></div>
                    <div class="fds-recet-order-cell min-numbr"><?php echo ($minimum_num) ?></div>
                    <div class="fds-recet-order-cell max-numbr"><?php echo ($maximum_num) ?></div>
                    <div class="fds-recet-order-cell choice-status"><strong style="background-color: <?php echo ($status_color) ?>;"><?php echo ($status_text) ?></strong></div>
                    <div class="fds-recet-order-cell choice-actions">
                        <div class="fds-menu-ations">
                            <a href="javascript:void(0);" class="fds-body-action fds-updte-choicegrp fds-link" data-nid="<?php echo ($choice_id) ?>" data-restaurant="<?php echo ($restaurant_id) ?>"><i class="fds-icon fds-edit"></i></a>
                            <a href="javascript:void(0);" class="fds-body-action fds-remove-action fds-remve-choicegrp fds-link" data-nid="<?php echo ($choice_id) ?>" data-restaurant="<?php echo ($restaurant_id) ?>"><i class="fds-icon fds-time-simple"></i></a>
                        </div>
                    </div>
                </div>
                <?php
            }
            $html = ob_get_clean();
            
            $responsedata['html'] = $html;
            wp_send_json($responsedata);
        }
        $result_html = '<p>' . esc_html__('no choice groups added.', 'wp-foodsearch') . '</p>';
        $responsedata = array('error' => '1', 'html' => $result_html);
        
        wp_send_json($responsedata);
    }
    
    public function remove_choice_group($post_data) {
        $choice_group_id = $post_data['n_id'];
        $restaurant_id = $post_data['restaurant'];
        
        $where = ' WHERE id=' . $choice_group_id . ' AND restaurant_id=' . $restaurant_id;
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_choice_group';

        $result = $wpdb->get_results("SELECT * FROM $table_name$where");

        if (isset($result[0])) {
            $wpdb->query("DELETE FROM $table_name WHERE id=" . $choice_group_id);
        }
        wp_send_json(array('msg' => esc_html__('item deleted successfully.', 'wp-foodsearch'), 'error' => '0'));
    }

    public function menuItemListIncId($id) {
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';
        $sql = "SELECT * FROM $table_name where id =" . $id;
        $result = $wpdb->get_row($sql);
        $sql = "SELECT * FROM $table_name where id NOT IN (" . $id . ") ORDER BY RAND() limit 99";
        $results = $wpdb->get_results($sql);
        $p = array();

        if (!empty($result)) {
            $p[$result->id] = $result->name;
        }
        if (!empty($results)) {
            foreach ($results as $post) {
                $p[$post->id] = $post->name;
            }
        }
        return $p;
    }

}

new Choice_Groups;
