<?php

namespace FoodSearch;

class Email_Settings {

    public function __construct() {

        $this->includes();

        add_filter('foodsearch_allplugin_settings_fields_list', array($this, 'email_templates_settings'), 5);
        add_filter('foodsearch_opts_sec_field_html', array($this, 'email_setins_section_field'), 15, 3);

        add_filter('foodsearch_opts_sec_field_conclass', array($this, 'email_field_maincon_class'), 10, 3);

        add_filter('foodsearch_opts_sec_before_fields', array($this, 'email_fields_header'), 10, 3);
    }

    public function includes() {
        include plugin_dir_path(dirname(__FILE__)) . 'classes/class-email-builder.php';
    }

    public function email_templates_settings($settings) {

        $sec_fields = array();
        $sec_fields[] = array(
            'id' => 'forgot_passwrod',
            'type' => 'email_switch',
            'title' => esc_html__('forgot passwrod', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );

        $settings_arr = array(
            'title' => esc_html__('email settings', 'wp-foodsearch'),
            'id' => 'user_email_setins',
            'desc' => esc_html__('user email template settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );

        $settings_arr = apply_filters('foodsearch_opts_user_emails_fields_list', $settings_arr);

        $settings['user_emails'] = $settings_arr;
        
        $sec_fields = array();
        $sec_fields[] = array(
            'id' => 'new_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('new order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'complete_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('completed order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'processing_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('processing order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'pending_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('pending order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'on_hold_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('on hold order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'refunded_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('refunded order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'cancelled_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('cancelled order', 'wp-foodsearch'),
            'desc' => '',
            'default' => '',
        );
        $sec_fields[] = array(
            'id' => 'failed_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('failed order', 'wp-foodsearch'),
            'desc' => '',
            'default' => '',
        );

        $settings_arr = array(
            'title' => esc_html__('email settings', 'wp-foodsearch'),
            'id' => 'restaurant_email_setins',
            'desc' => esc_html__('restaurant email template settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );

        $settings_arr = apply_filters('foodsearch_opts_restaurant_emails_fields_list', $settings_arr);

        $settings['restaurant_emails'] = $settings_arr;

        $sec_fields = array();
        $sec_fields[] = array(
            'id' => 'new_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('new order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'complete_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('completed order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'processing_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('processing order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'pending_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('pending order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'on_hold_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('on hold order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'refunded_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('refunded order', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'cancelled_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('cancelled order', 'wp-foodsearch'),
            'desc' => '',
            'default' => '',
        );
        $sec_fields[] = array(
            'id' => 'failed_order_email',
            'type' => 'email_switch',
            'title' => esc_html__('failed order', 'wp-foodsearch'),
            'desc' => '',
            'default' => '',
        );

        $settings_arr = array(
            'title' => esc_html__('email settings', 'wp-foodsearch'),
            'id' => 'customer_email_setins',
            'desc' => esc_html__('customer email template settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );

        $settings_arr = apply_filters('foodsearch_opts_customer_emails_fields_list', $settings_arr);

        $settings['customer_emails'] = $settings_arr;

        return $settings;
    }

    public function email_tabs() {
        $email_tabs = apply_filters('foodsearch_opts_email_relate_sections', array(
            'restaurant_emails',
            'customer_emails',
            'user_emails',
        ));

        return $email_tabs;
    }

    public function email_field_maincon_class($class, $field, $sec_id) {
        $field_type = $field['type'];

        if ($field_type == 'email_switch') {
            $class .= ' fds-bar-switchr-field';
        }

        return $class;
    }

    public function email_setins_section_field($html, $field, $sec_id) {

        $field_type = $field['type'];

        if ($field_type == 'email_switch') {
            $field_id = isset($field['id']) ? $field['id'] : '';
            $field_html_class = $field_id != '' ? ' fds-setfield-' . str_replace('_', '-', $field_id) : '';

            $tab = isset($_GET['tab']) ? $_GET['tab'] : '';
            $section = isset($_GET['section']) ? $_GET['section'] : '';
            $edit_url = add_query_arg(array('page' => 'foodsearch-plugin-settings', 'tab' => $tab, 'section' => $section, 'email' => $field_id, 'action' => 'fds-email-editor'), admin_url('admin.php'));
            ob_start();
            ?>
            <div class="setsec-field-holdr<?php echo ($field_html_class) ?> fds-opt-barswich">
                <div class="fds-barswich-columns">
                    <div class="fds-panel-title"><?php echo (isset($field['title']) ? $field['title'] : '') ?></div>
                    <div class="fds-panel-data">text/html</div>
                    <div class="fds-panel-data"><?php esc_html_e('restaurant', 'wp-foodsearch') ?></div>
                    <div class="fds-panel-action-btns">
                        <?php echo apply_filters('foodsearch_settings_field_switch_button_html', '', $field, $sec_id) ?>
                        <div class="edit-btn fds-btn fds-small-btn" style="display: none;">
                            <a href="<?php echo ($edit_url) ?>" class="fds-has-bg fds-link"><?php esc_html_e('edit', 'wp-foodsearch') ?></a>
                        </div>
                    </div>
                </div>
                <?php
                if (isset($field['desc']) && $field['desc'] != '') {
                    ?>
                    <p><?php echo ($field['desc']) ?></p>
                    <?php
                }
                ?>
            </div>
            <?php
            $html = ob_get_clean();
        }

        return $html;
    }

    public function email_fields_header($html, $atts, $settings_tab) {

        $email_tabs = $this->email_tabs();
        if (in_array($settings_tab, $email_tabs)) {
            ob_start();
            ?>
            <div class="fds-content-full-column fds-opts-barswiches-hdr">
                <div class="fds-barswich-columns">
                    <div class="fds-panel-title"><?php esc_html_e('email', 'wp-foodsearch') ?></div>
                    <div class="fds-panel-data"><?php esc_html_e('content type', 'wp-foodsearch') ?></div>
                    <div class="fds-panel-data"><?php esc_html_e('recipient(s)', 'wp-foodsearch') ?></div>
                    <div class="fds-panel-action-btns"><?php esc_html_e('actions', 'wp-foodsearch') ?></div>
                </div>
            </div>
            <?php
            $html .= ob_get_clean();
        }

        return $html;
    }

}

new Email_Settings();

