<?php

namespace FoodSearch;

class Radius_Check {

    var $maxLat;
    var $minLat;
    var $maxLong;
    var $minLong;

    // Start function for radius search 
    function __construct($Latitude, $Longitude, $Miles, $unit = 'miles') {
        global $maxLat, $minLat, $maxLong, $minLong;
        $EQUATOR_LAT_MILE = 69.172; // in MIles
        if ($unit == 'km') {
            $Miles = $Miles / 1.60934;
        }
        $maxLat = $Latitude + $Miles / $EQUATOR_LAT_MILE;
        $minLat = $Latitude - ($maxLat - $Latitude);
        $maxLong = $Longitude + $Miles / (cos($minLat * M_PI / 180) * $EQUATOR_LAT_MILE);
        $minLong = $Longitude - ($maxLong - $Longitude);
    }

    // Start function for get max latitude 
    static function max_latitude() {
        return $GLOBALS["maxLat"];
    }

    // Start function for get Min latitude 
    static function min_latitude() {
        return $GLOBALS["minLat"];
    }

    // Start function for get Max Longitude

    static function max_longitude() {
        return $GLOBALS["maxLong"];
    }

    // Start function for get Min Longitude
    static function min_longitude() {
        return $GLOBALS["minLong"];
    }

}


class Distance_Check {

    // Start function for calculate distance 
    public static function calculate($dblLat1, $dblLong1, $dblLat2, $dblLong2, $unit = 'K', $restaurant_id = 0) {

        $earth_radius = 3963.19; // in miles
        $dist = 0;

        if ($dblLat1 == 'NaN') {
            $dblLat1 = 0;
        }
        if ($dblLong1 == 'NaN') {
            $dblLong1 = 0;
        }
        if ($dblLat2 == 'NaN') {
            $dblLat2 = 0;
        }
        if ($dblLong2 == 'NaN') {
            $dblLong2 = 0;
        }

        if (is_numeric($dblLat1) && is_numeric($dblLong1) && is_numeric($dblLat2) && is_numeric($dblLong2)) {
            //convert degrees to radians
            $dblLat1 = number_format((float)$dblLat1, 14, '.', '');
            $dblLong1 = number_format((float)$dblLong1, 14, '.', '');
            $dblLat2 = number_format((float)$dblLat2, 14, '.', '');
            $dblLong2 = number_format((float)$dblLong2, 14, '.', '');
            //echo $restaurant_id . ' [] '; echo($dblLat1);echo ':';echo($dblLong1);echo ' :: ';echo($dblLat2);echo ':';echo($dblLong2);echo "\n";
            $dblLat1 = $dblLat1 * M_PI / 180;
            $dblLong1 = $dblLong1 * M_PI / 180;
            $dblLat2 = $dblLat2 * M_PI / 180;
            $dblLong2 = $dblLong2 * M_PI / 180;
            
            if ($dblLat1 != $dblLat2 || $dblLong1 != $dblLong2) {
                //the two points are not the same
                $dist = sin($dblLat1) * sin($dblLat2) + cos($dblLat1) * cos($dblLat2) * cos($dblLong2 - $dblLong1);
                $dist = $earth_radius * (-1 * atan($dist / sqrt(1 - $dist * $dist)) + M_PI / 2);
            }
            if ($unit == 'K') {
                $dist = $dist * 1.609344;
            }
            $dist = number_format($dist, 2, '.', '');
        }
        return $dist;
    }
}