<?php

use FoodSearch\Common_Functions;
use FoodSearch\user_orders as FoodSearch_Orders;

class resturant_Orders {
// /** @var WC_API_Server the API server */
     protected $server;
    protected $post_type = 'shop_order';
    protected $author;
    // /**
	//  * Setup class
	//  *
	//  * @since 2.1
	//  * @param WC_API_Server $server
	//  */
    public function __construct() {
       
       // $this->get_orders_details(4904);
        add_filter('foodsearch_restaurant_dash_orders_html', [$this, 'content'], 10, 4);
        
        add_action('rest_api_init', [$this, 'register_api'],10);
    }
    
    public function register_api() {

        register_rest_route('wp/v1', 'wc-restaurant-orders-load-more', array(
            'methods' => 'GET',
            'callback' => [$this, 'load_more_orders_list'],
           'permission_callback' =>  'admin_permissions_check',
        ));        
        register_rest_route('wp/v1', 'restaurant-wc-order-detail-html', array(
            'methods' => 'POST',
            'callback' => array($this, 'get_wc_restaurant_orderdetail'),
            'permission_callback' =>  'admin_permissions_check',
        ));       
        register_rest_route('wp/v1', 'restaurant-wc-update-order-status', array(
            'methods' => 'POST',
            'callback' => array($this, 'wc_orderstatus_change'),
            'permission_callback' =>  'admin_permissions_check',
        ));
    }

    public function wc_orderstatus_change(){
        $order_id = $_POST['nid'];
        $status = $_POST['status'];
        $order = new WC_Order($order_id);
        if (empty($order) || !isset($status)) {
            wp_send_json(array('msg' => esc_html__('error: order not found.', 'wp-foodsearch'), 'error' => '1'));
        }
        else{
            $order->update_status( $status );
            
            wp_send_json(array('msg' => esc_html__('status updated successfully.', 'wp-foodsearch'), 'error' => '0'));
        }
    }

    public function content($html, $menu_data, $section_key, $element_key) {

        global $foodsearch_user_orders_obj;

        wp_enqueue_style('jquery-datetimepicker');
        wp_enqueue_script('jquery-datetimepicker');
        
        $element_data = $menu_data['sections'][$section_key]['elements'][$element_key];
        
        $element_label = isset($element_data['label']) ? $element_data['label'] : '';
        if ($element_label == '') {
            $element_label = esc_html__('recent orders', 'wp-foodsearch');
        }

        $user_id = get_current_user_id();

       $restaurant_id = Common_Functions::user_restaurant_id($user_id);
       
        
        $this->author = $restaurant_id;
        unset($_SESSION['searchData']);
        $order_statuses =  $this->get_order_statuses();
        $get_tab = get_query_var('tab');
        $args['author']  = $this->author;
        $get_keyword =  '';
        $get_order_type = isset($_GET['filter_orders_type']) ? foodsearch_esc_html($_GET['filter_orders_type']) : '';
        $get_order_status = isset($_GET['filter_orders_status']) ? foodsearch_esc_html($_GET['filter_orders_status']) : '';
        $get_order_date = isset($_GET['filter_orders_date']) ? foodsearch_esc_html($_GET['filter_orders_date']) : '';
        $per_page = get_option('posts_per_page');
        $args= [];
        $status = '';
        $search = [];
        if(isset($_GET['filter_orders_keyword']) && !empty($_GET['filter_orders_keyword'])){
           $args['search'] =  $get_keyword = foodsearch_esc_html($_GET['filter_orders_keyword']);
        }
        
        if(isset($_GET['filter_orders_status'])&& !empty($_GET['filter_orders_status'])){
            $status = foodsearch_esc_html($_GET['filter_orders_status']);
        }
        
        if(isset($_GET['filter_orders_date']) && !empty($_GET['filter_orders_date'])){
            $date = foodsearch_esc_html($_GET['filter_orders_date']);
            $args['after'] = $date.'T00:00:00Z';
            $args['before'] = $date.'T23:59:59Z';
        }
        if ( ! empty( $args['search'] ) ) {
			$args['include'] = wc_order_search( $args['search'] );
		}
        
        if ( ! empty( $_GET['filter_orders_type'] ) ) {
			$args['filter_orders_type'] = $_GET['filter_orders_type'];
		}
        $_SESSION['searchData']['filters'] = $args;
        $_SESSION['searchData']['status'] = $status;
        $_SESSION['searchData']['search'] = $search;
        $orders_list = $this->get_orders($search,$args, $status);
        $total_orders = $this->get_orders_count($status,$args);
        $total_orders = $total_orders['count'];
        ob_start();
        ?>
        <div class="fds-section-title-wrap fds-restaurant-orders-page">
            <?php
            if ($element_label != '') {
                ?>
                <h2 class="fds-heading-title"><?php echo ($element_label) ?></h2>
                <?php
            }
            
           
            ?>
            <div class="fds-order-filters">
                <form class="restaurant-filter-orders-form" method="get" autocomplete="off">
                    <span class="fds-dashboard-inner-top-filter"><?php esc_html_e('filter by', 'wp-foodsearch'); ?>:</span>
                    <div class="fds-form-field">
                        <div class="fds-select-field">
                            <select class="fds-select-dropdown" name="filter_orders_type" data-placeholder="<?php esc_html_e('order type', 'wp-foodsearch'); ?>">
                                <option value=""><?php esc_html_e('order type', 'wp-foodsearch'); ?></option>
                                <option value="delivery"<?php echo ($get_order_type == 'delivery' ? ' selected' : '') ?>><?php esc_html_e('delivery', 'wp-foodsearch'); ?></option>
                                <option value="take_away"<?php echo ($get_order_type == 'take_away' ? ' selected' : '') ?>><?php esc_html_e('take away', 'wp-foodsearch'); ?></option>
                            </select>
                        </div>
                    </div>
                    <div class="fds-form-field">
                        <div class="fds-select-field">
                            <select class="fds-select-dropdown" name="filter_orders_status" data-placeholder="<?php esc_html_e('order status', 'wp-foodsearch'); ?>">
                                <option value=""><?php esc_html_e('order status', 'wp-foodsearch'); ?></option>
                                <?php
                               
                                //exit();
                                foreach ($order_statuses['order_statuses'] as $status_key => $status_label) {
                                    if ($status_key == 'trash' || $status_key == 'on-hold' || $status_key == 'refunded' || $status_key == 'failed') {
                                        continue;
                                    }
                                    ?>
                                    <option value="<?php echo ($status_key) ?>"<?php echo ($status_key==$get_order_status ? ' selected' : ''); ?>><?php echo ($status_label); //echo '<pre>'.print_r($order_statuses,true).'</pre>'; ?></option>
                                    <?php
                                }
                                ?>
                            </select>
                        </div>
                    </div>
                    <div class="fds-form-field">
                        <input type="text" name="filter_orders_date" class="fds-input-style fds-filter-orders-date" value="<?php echo ($get_order_date) ?>" placeholder="<?php esc_html_e('order date', 'wp-foodsearch'); ?>">
                    </div>
                    <div class="fds-form-field">
                        <div class="fds-search-field">
                            <input type="hidden" name="tab" value="<?php echo ($get_tab) ?>">
                            <input type="text" name="filter_orders_keyword" class="fds-input-style" value="<?php echo ($get_keyword) ?>" placeholder="<?php esc_html_e('order id/customer', 'wp-foodsearch'); ?>">
                            <input type="submit" value="">
                            <i class="fds-icon fds-search"></i>
                        </div>
                    </div>
                </form>
                <i class="fds-dashboard-inner-top-money fds-icon fds-shopping-cart"></i>
            </div>
            <?php
            //
            add_action('wp_footer', function() {
                ?>
                <script>
                    jQuery(document).ready(function () {
                        jQuery('.fds-filter-orders-date').datetimepicker({
                            format: 'd-m-Y',
                            timepicker: false,
                            maxDate: '<?php echo current_time('d-m-Y') ?>'
                        });
                    });
                </script>
                <?php
            }, 99);
            ?>
        </div>
        <?php        
        if (!empty($orders_list)) {
            ?>
            <div id="fds-user-orders-mainlist" class="fds-recet-order-list">
                <div class="fds-recet-order-thead">
                    <div><?php esc_html_e('date', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('order id', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('type', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('detail', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('order price', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('comission', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('status', 'wp-foodsearch'); ?></div>
                    <div><?php esc_html_e('detail', 'wp-foodsearch'); ?></div>
                </div>
                <?php
                foreach ($orders_list['orders'] as $order_result) {
                    $order_id = $order_result['id'];
                    
                    $this->order_itm_detail($order_id, $order_result, $user_id);
                }
                ?>
            </div>
            <?php
           
            if ($total_orders > $per_page) {
                $total_pages = ceil($total_orders / $per_page);
                ?>
                <div id="fds-wc-restaurant-orders-morebtn" class="fds-lodmore-btnsec">
                    <div class="fds-btn fds-medium-btn">
                        <a href="#" class="fds-lodmore-btn fds-has-bg fds-link" data-nid="<?php echo ($user_id) ?>" data-tpages="<?php echo($total_pages) ?>" data-gtopage="2"><?php esc_html_e('load more', 'wp-foodsearch') ?></a>
                    </div>
                </div>
                <?php
            }
            add_action('wp_footer', function() {
                ?>
                <div id="fds-orderdet-mpopup" class="fds-modal-popup fds-popup-hide fds-orderdet-modal">
                    <div class="fds-modal-container">
                        <a href="javascript:void(0);" class="fds-popup-closebtn fds-link"><i class="fds-icon fds-time-simple"></i></a>
                        <div class="fds-modal-inner-area">
                            <div class="fds-modal-content-area">
                                <div class="fds-dynm-modal-content">
                                    <div class="fds-loader-holder"><div class="fds-loader"></div></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <?php
            }, 20);
        } else {
            ?>
            <div class="foodsearch-noitm-found">
                <img src="<?php echo foodsearch_plugin_get_url('assets/images/not-found.svg') ?>" alt="">
                <p><?php esc_html_e('no record found.', 'wp-foodsearch') ?></p>
            </div>
            <?php
        }
        $html = ob_get_clean();

        return $html;
    }
    
    public function order_itm_detail($order_id, $order_result, $user_id) {
        global $foodsearch_user_orders_obj;
        //$order_statuses =  $this->call_exicute('wc/v3/orders/statuses');
        $order_statuses =  $this->get_order_statuses();
        $order_statuses =$order_statuses['order_statuses'];
        $restaurant_id = Common_Functions::user_restaurant_id($user_id);
        $order_type = get_post_meta($order_id,'_foodsearch_order_type',true);
       // $order = $this->call_exicute('/wc/v3/orders/'.$order_id);
        $order = $this->get_order($order_id);
        $order = $order['order'];
        //   echo '<pre>'.print_r($order,true).'</pre>';
        //   exit();
        //foreach($orders as $order){
            $order_title = 'Order #' . $order['id'];
            $create_date = $order['date_created'];
            $create_date_formate = date_i18n(get_option('date_format'), strtotime($create_date));
            $first_name =  $order['billing']['first_name'];
            $last_name =  $order['billing']['last_name'];
            if ($first_name != '' && $last_name != '') {
                $order_title .= " ($first_name $last_name)";
            }
            $order_net_total = $order['total'];
            $order_status = $order['status'];
            $status_label = $foodsearch_user_orders_obj->get_order_status_tclr($order_status);
            $status_color = $foodsearch_user_orders_obj->get_order_status_tclr($order_status, 'color');
            $order_status_updated = false;
            if (($order_status == 'completed' || $order_status == 'cancelled')) {
                $order_status_updated = true;              
            }
        ?>
        <div class="fds-recet-order-tbody">
            <div class="fds-recet-order-cell"><?php echo ($create_date_formate) ?></div>
            <div class="fds-recet-order-cell">#<?php echo ($order['id']) ?></div>
            <div class="fds-recet-order-cell"><a class="fds-recet-order-btn fds-link"><?php echo (str_replace('_',' ',$order_type)); // == 'take_away' ? esc_html__('take away', 'wp-foodsearch') : esc_html__('delivery', 'wp-foodsearch')) ?></a></div>
            <div class="fds-recet-order-cell"><?php echo ($order_title) ?></div>
            <div class="fds-recet-order-cell"><span><?php echo (Common_Functions::get_formatted_price($order_net_total)) ?></span></div>
            <div class="fds-recet-order-cell"><span>-<?php echo (Common_Functions::get_formatted_price(0)) ?></span></div>
            <?php
            if ($order_status_updated) {
                ?>
                <div class="fds-recet-order-cell"><strong style="background-color: <?php echo ($status_color) ?>;"><?php echo ($status_label) ?></strong></div>
                <?php
            } else {
                ?>
                <div class="fds-recet-order-cell">
                    <div class="fds-restaurant-order-status" data-nid="<?php echo ($order_id) ?>">
                        <strong class="fds-to-orderstatus-update fds-update-anything-action" style="background-color: <?php echo ($status_color) ?>;"><?php echo ($status_label) ?> <i class="fds-icon fds-down-arrow"></i></strong>
                        <ul class="fds-order-status-list-box fds-wc-order-status-list fds-options-wrap">
                            <?php                             
                            foreach ( $order_statuses as $status_key => $status_label) {
                                if ($status_key == 'trash' || $status_key == 'on-hold' || $status_key == 'refunded' || $status_key == 'failed') {
                                    continue;
                                }
                                ?>
                                <li class="fds-list-item"><a href="#" class="fds-link" data-key="<?php echo ($status_key) ?>"><?php echo $status_label; ?></a></li>
                                <?php
                            }
                            ?>
                        </ul>
                    </div>
                </div>
                <?php
            }
            ?>
            <div class="fds-recet-order-cell"><a href="#" class="fds-recet-order-link fds-get-wc-orderdet-popup fds-link" data-restaurant="<?php echo ($restaurant_id) ?>" data-nid="<?php echo ($order_id) ?>"><?php esc_html_e('detail', 'wp-foodsearch'); ?> <i class="fds-icon fds-plus-circle-o"></i></a></div>
        </div>
        <?php
        //}
    }
    public function load_more_orders_list() {
        $user_id = $_REQUEST['n_id'];
        $page_num = $_REQUEST['page_num'];


       $restaurant_id = Common_Functions::user_restaurant_id($user_id);
      
        $args =  $_SESSION['searchData']['filters'] ;
        $status = $_SESSION['searchData']['status'] ;
        $search = $_SESSION['searchData']['search'] ;
        //$args['page'] = $page_num;
        //echo '<pre>'.print_r($args,true).'</pre>';
       
        $orders_list = $this->get_orders($search,$args, $status,$page_num);
       // echo '<pre>'.print_r($orders_list,true).'</pre>';
       // exit();
       // $orders_list = $foodsearch_user_orders_obj->get_restaurant_filtered_orders($restaurant_id, '', $page_num);
        
        ob_start();
        foreach ($orders_list['orders'] as $order_result) {
            $order_id = $order_result['id'];

            $this->order_itm_detail($order_id, $order_result, $user_id);
        }
        $html = ob_get_clean();
        
        wp_send_json(array('error' => '0', 'html' => $html));
    }
    public function get_wc_restaurant_orderdetail($post_data) {
        global $foodsearch_user_orders_obj,$foodsearch_plugin_settings;
        //$order = $this->call_exicute('/wc/v3/orders/'.$post_data['n_id']);
        //wp_send_json(array('html' => $order, 'msg' => '', 'error' => '0'));
       // echo '<pre>'.print_r($order,true).'</pre>';
        //exit();
        $order = $this->get_order($post_data['n_id']);
        //  echo '<pre>'.print_r($order,true).'</pre>';
        // exit();
        $order = $order['order'];
        $order_id = $order['id'];
        $first_name = $order['billing']['first_name'];
        $last_name = $order['billing']['last_name'];
        $billing_email =$order['billing']['email'];
        $billing_phone = $order['billing']['phone'];
        $billing_address = $order['billing']['address_1'];
        $billing_address_lat = '';
        $billing_address_lng = '';

        $customer_name = '';
        if ($first_name != '') {
            $customer_name .= $first_name;
            if ($last_name != '') {
                $customer_name .= ' ' . $last_name;
            }
        }

        $order_status = $order['status'];
        
        $status_list = FoodSearch_Orders::get_order_statuses();
        
        $order_status_label = $foodsearch_user_orders_obj->get_order_status_tclr($order_status);
        
        $create_date = $order['date_created'];
        $create_date_formate = date_i18n(get_option('date_format'), strtotime($create_date));
        $create_time_formate = date_i18n(get_option('time_format'), strtotime($create_date));

        ob_start();
        ?>
        <div class="fds-booking-detail-title">
            <h2 class="fds-heading-title"><?php esc_html_e('order detail', 'wp-foodsearch'); ?></h2>
            <span><?php printf(esc_html__('status: %s', 'wp-foodsearch'), $order_status_label); ?></span>
        </div>
        <ul class="fds-booking-detail-info fds-options-wrap">
            <li class="fds-list-item">
                <span><?php esc_html_e('order date', 'wp-foodsearch'); ?></span>
                <small><?php echo ($create_date_formate) ?></small>
                <small><?php echo ($create_time_formate) ?></small>
            </li>
            <li class="fds-list-item">
                <span><?php esc_html_e('customer name', 'wp-foodsearch'); ?></span>
                <small><?php echo ($customer_name) ?></small>
                <small><?php printf(esc_html__('order id: #%s', 'wp-foodsearch'), $order_id); ?></small>
            </li>
            <li class="fds-list-item">
                <span><?php esc_html_e('customer contact', 'wp-foodsearch'); ?></span>
                <?php
                if ($billing_phone != '') {
                    ?>
                    <a href="tel:<?php echo ($billing_email) ?>" class="fds-link"><?php echo ($billing_phone) ?></a>
                    <?php
                }
                ?>
                <a href="mailto:<?php echo ($billing_email) ?>" class="fds-link fds-cus-email"><?php echo ($billing_email) ?></a>
            </li>
        </ul>

        <div class="fds-plugin-modal-box-inner">
            <?php
            if ($billing_address != '') {
                if ($billing_address_lat != '' && $billing_address_lng != '') {
                    $view_map_loc = $billing_address_lat . ',' . $billing_address_lng;
                } else {
                    $view_map_loc = urlencode($billing_address);
                }
                ?>
                <div class="fds-ordersum-address">
                    <span class="fds-order-address-icon"><i class="fds-icon fds-marker-thin"></i></span>
                    <small class="fds-order-address-holdr"><?php echo ($billing_address) ?></small>
                    <div class="fds-btn fds-small-btn">
                        <a href="https://www.google.com/maps/search/<?php echo ($view_map_loc) ?>" class="fds-link fds-has-bg" target="_blank"><?php esc_html_e('view on map', 'wp-foodsearch'); ?></a>
                    </div>
                </div>
                <span class="fds-booking-detail-mini-title"><?php esc_html_e('order summary', 'wp-foodsearch'); ?></span>
                <?php
            }
            $order_items = $order['line_items'];
            if (!empty($order_items)) {

                $order_subtotal = $order['total']-$order['total_tax'];
                $order_net_total = $order['total'];
                ?>
                <div id="fds-order-items-list" class="orderdet-items-wrap">
                    <div class="orderdet-items-inside">
                        <div class="fds-table-items-wrapper">
                            <ul class="fds-table-item-row item-row-heder fds-options-wrap">
                                <li class="table-item-heditm itm-name fds-list-item"><?php esc_html_e('item', 'wp-foodsearch'); ?></li>
                                <li class="table-item-heditm itm-cost fds-list-item"><?php esc_html_e('cost', 'wp-foodsearch'); ?></li>
                                <li class="table-item-heditm itm-qty fds-list-item"><?php esc_html_e('qty', 'wp-foodsearch'); ?></li>
                                <li class="table-item-heditm itm-totl fds-list-item"><?php esc_html_e('total', 'wp-foodsearch'); ?></li>
                            </ul>
                            <?php
                            $items_counter = 1;
                            $total_order_items = count($order_items);
                            $menu_itms_open = false;
                            foreach ($order_items as $order_item) {
                                $order_item_id = $order_item['id'];
                                $order_item_name = $order_item['name'];
                               // $order_item_type = $order_item['order_item_type'];
                               // if ($order_item_type == 'menu_item' || $order_item_type == 'menu_item_extra') {
                                   
                                    $mtotal = 0;
                                    if(is_array($order_item['meta_data']) && count($order_item['meta_data'])>=1){
                                        $mtotal = 0;
                                        foreach($order_item['meta_data'] as $meta){
                                           $value =  preg_replace("/[^0-9\.]/", '', $meta->value);
                                           $mtotal +=$value;

                                        }
                                    }
                                    $item_menu_id = $order_item['id'];
                                    $item_qty = $order_item['quantity'];
                                    $item_subtotal = $order_item['subtotal'];
                                    $menu_itm_label = $order_item_name;

                                    $item_alltotal = $item_subtotal;                                   
                                   
                                        $rand_num = rand(1000000, 9999999);
                                        echo '<div class="fds-item-table-list fds-to-list-itms" data-id="' . $rand_num . '">';
                                   
                                    ?>
                                    <ul class="fds-order-item-row fds-options-wrap">
                                        <li class="table-item-cell itm-name fds-list-item">
                                            <!-- <img src="<?php //echo ($image_src) ?>" class="order-itm-thumbnail" alt=""> -->
                                            <span class="order-name"><?php echo ($menu_itm_label) ?></span>
                                        </li>
                                        <li class="table-item-cell itm-cost fds-list-item">
                                            <span class="order-itm-amount"><?php echo (Common_Functions::get_formatted_price( (($item_subtotal - ( $mtotal*$item_qty))/$item_qty))) ?></span>
                                        </li>
                                        <li class="table-item-cell itm-qty fds-list-item">
                                            <small class="times">x</small> <?php echo ($item_qty) ?>
                                        </li>
                                        <li class="table-item-cell itm-totl fds-list-item">
                                            <span class="order-itm-total"><?php echo (Common_Functions::get_formatted_price($item_alltotal)) ?></span>
                                        </li>
                                    </ul>
                                    <?php
                                    if(is_array($order_item['meta_data']) && count($order_item['meta_data'])>=1){

                                   
                                    ?>
                                   
                                        <?php
                                        foreach($order_item['meta_data'] as $meta){
                                            $mp =  preg_replace("/[^0-9\.]/", '', $meta->value);
                                           ?>
                                            <div class="fds-table-list-items items-con-<?=$rand_num;?>">
                                    <ul class="fds-order-item-row fds-options-wrap">
                                            <li class="table-item-cell itm-name fds-list-item">
                                            <!-- <img src="<?php //echo ($image_src) ?>" class="order-itm-thumbnail" alt=""> -->
                                            <span class="order-name"><?php echo ( $meta->key) ?></span>
                                        </li>
                                        <li class="table-item-cell itm-cost fds-list-item">
                                            <span class="order-itm-amount"><?php echo wc_price($mp) ?></span>
                                        </li>
                                        <li class="table-item-cell itm-qty fds-list-item">
                                            <small class="times">x</small> <?php echo ($item_qty) ?>
                                        </li>
                                        <li class="table-item-cell itm-totl fds-list-item">
                                            <span class="order-itm-total"><?php echo wc_price($mp*$item_qty) ?></span>
                                        </li>
                                        </ul>
                                    </div>
                                           <?php 
                                        }
                                        ?>
                                       
                                    
                                    <?php
                                     }
                                     ?>
                                     </div>
                                     <?php
                                   
                                    $items_counter++;
                               // }
                            }
                            ?>
                        </div>
                        <div class="fds-order-totals-items">
                            <ul class="fds-total-itmscon fds-options-wrap">
                                <li class="ordrtotl-label fds-list-item"><?php esc_html_e('items subtotal:', 'wp-foodsearch'); ?></li>
                                <li class="fds-list-item">
                                    <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($order_subtotal)) ?></span>
                                </li>
                            </ul>
                            <?php
                            $delivery_fee = isset($order['shipping_total']) ? $order['shipping_total'] : '';
                            if ($delivery_fee > 0) {
                                ?>
                                <ul class="fds-total-itmscon fds-options-wrap">
                                    <li class="ordrtotl-label fds-list-item"><?php esc_html_e('delivery charges:', 'wp-foodsearch'); ?></li>
                                    <li class="fds-list-item">
                                        <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($delivery_fee)) ?></span>
                                    </li>
                                </ul>
                                <?php
                            }
                            
                            //echo '<pre>'.print_r($order['tax_lines'],true).'</pre>';
                            if(is_array($order['tax_lines'])&& count($order['tax_lines'])>0){
                            $vat_amount = $order['tax_lines'][0]['total'];
                                ?>
                                <ul class="fds-total-itmscon fds-options-wrap">
                                    <li class="ordrtotl-label fds-list-item"><?php esc_html_e('vat:', 'wp-foodsearch'); ?></li>
                                    <li class="fds-list-item">
                                        <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($vat_amount)) ?></span>
                                    </li>
                                </ul>
                               <?php }?>
                            <ul class="fds-total-itmscon fds-options-wrap">
                                <li class="ordrtotl-label fds-list-item"><?php esc_html_e('order total:', 'wp-foodsearch'); ?></li>
                                <li class="fds-list-item">
                                    <span class="ordrtotl-amount"><?php echo (Common_Functions::get_formatted_price($order_net_total)) ?></span>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <?php
            }
            ?>
        </div>
        <?php
        $html = ob_get_clean();
        
        wp_send_json(array('html' => $html, 'msg' => '', 'error' => '0'));
    }
    public function get_orders( $fields = null, $filter = array(), $status = null, $page = 1 ) {
       
		if ( ! empty( $status ) ) {
			$filter['status'] = $status;
		}
		$filter['page'] = $page;

		$query = $this->query_orders( $filter );
        
		$orders = array();

		foreach ( $query->posts as $order_id ) {
           
            if(isset($filter['include']) && in_array($order_id,$filter['include'])){
			    $orders[] = current( $this->get_order( $order_id, $fields, $filter ) );
            }
            else if(!isset($filter['include'])){
                $orders[] = current( $this->get_order( $order_id, $fields, $filter ) );
            }
		}
    
		return array( 'orders' => $orders );
	}

    protected function is_readable( $post ) {

		return $this->check_permission( $post, 'read' );
	}
    private function check_permission( $post, $context ) {

		if ( ! is_a( $post, 'WP_Post' ) ) {
			$post = get_post( $post );
		}

		if ( is_null( $post ) ) {
			return false;
		}

		$post_type = get_post_type_object( $post->post_type );

		if ( 'read' === $context ) {
			return current_user_can( $post_type->cap->read_private_posts, $post->ID );
		} elseif ( 'edit' === $context ) {
			return current_user_can( $post_type->cap->edit_post, $post->ID );
		} elseif ( 'delete' === $context ) {
			return current_user_can( $post_type->cap->delete_post, $post->ID );
		} else {
			return false;
		}
	}
	/**
	 * Get the order for the given ID.
	 *
	 * @since 2.1
	 * @param int $id The order ID.
	 * @param array $fields Request fields.
	 * @param array $filter Request filters.
	 * @return array|WP_Error
	 */
	public function get_order( $id, $fields = null, $filter = array() ) {

		// Ensure order ID is valid & user has permission to read.
		//$id = $this->validate_request( $id, $this->post_type, 'read' );
        
		if ( is_wp_error( $id ) ) {
			return $id;
		}

		// Get the decimal precession.
		$dp     = ( isset( $filter['dp'] ) ? intval( $filter['dp'] ) : 2 );
		$order  = wc_get_order( $id );
		$expand = array();

		if ( ! empty( $filter['expand'] ) ) {
			$expand = explode( ',', $filter['expand'] );
		}

		$order_data = array(
			'id'                        => $order->get_id(),
			'order_number'              => $order->get_order_number(),
			'order_key'                 => $order->get_order_key(),
			'date_created'                => $this->format_datetime( $order->get_date_created() ? $order->get_date_created()->getTimestamp() : 0, false, false ), // API gives UTC times.
			'date_updated'                => $this->format_datetime( $order->get_date_modified() ? $order->get_date_modified()->getTimestamp() : 0, false, false ), // API gives UTC times.
			'date_completed'              => $this->format_datetime( $order->get_date_completed() ? $order->get_date_completed()->getTimestamp() : 0, false, false ), // API gives UTC times.			
            'status'                    => $order->get_status(),
			'currency'                  => $order->get_currency(),
			'total'                     => wc_format_decimal( $order->get_total(), $dp ),
			'subtotal'                  => wc_format_decimal( $order->get_subtotal(), $dp ),
			'total_line_items_quantity' => $order->get_item_count(),
			'total_tax'                 => wc_format_decimal( $order->get_total_tax(), $dp ),
			'total_shipping'            => wc_format_decimal( $order->get_shipping_total(), $dp ),
			'cart_tax'                  => wc_format_decimal( $order->get_cart_tax(), $dp ),
			'shipping_tax'              => wc_format_decimal( $order->get_shipping_tax(), $dp ),
			'total_discount'            => wc_format_decimal( $order->get_total_discount(), $dp ),
			'shipping_methods'          => $order->get_shipping_method(),
			'payment_details' => array(
				'method_id'    => $order->get_payment_method(),
				'method_title' => $order->get_payment_method_title(),
				'paid'         => ! is_null( $order->get_date_paid() ),
			),
			'billing' => array(
				'first_name' => $order->get_billing_first_name(),
				'last_name'  => $order->get_billing_last_name(),
				'company'    => $order->get_billing_company(),
				'address_1'  => $order->get_billing_address_1(),
				'address_2'  => $order->get_billing_address_2(),
				'city'       => $order->get_billing_city(),
				'state'      => $order->get_billing_state(),
				'postcode'   => $order->get_billing_postcode(),
				'country'    => $order->get_billing_country(),
				'email'      => $order->get_billing_email(),
				'phone'      => $order->get_billing_phone(),
			),
			'shipping_address' => array(
				'first_name' => $order->get_shipping_first_name(),
				'last_name'  => $order->get_shipping_last_name(),
				'company'    => $order->get_shipping_company(),
				'address_1'  => $order->get_shipping_address_1(),
				'address_2'  => $order->get_shipping_address_2(),
				'city'       => $order->get_shipping_city(),
				'state'      => $order->get_shipping_state(),
				'postcode'   => $order->get_shipping_postcode(),
				'country'    => $order->get_shipping_country(),
			),
			'note'                      => $order->get_customer_note(),
			'customer_ip'               => $order->get_customer_ip_address(),
			'customer_user_agent'       => $order->get_customer_user_agent(),
			'customer_id'               => $order->get_user_id(),
			'view_order_url'            => $order->get_view_order_url(),
			'line_items'                => array(),
			'shipping_lines'            => array(),
			'tax_lines'                 => array(),
			'fee_lines'                 => array(),
			'coupon_lines'              => array(),
		);

		// Add line items.
		foreach ( $order->get_items() as $item_id => $item ) {
			$product    = $item->get_product();
			$hideprefix = ( isset( $filter['all_item_meta'] ) && 'true' === $filter['all_item_meta'] ) ? null : '_';
			$item_meta  = $item->get_all_formatted_meta_data( $hideprefix );

			foreach ( $item_meta as $key => $values ) {
				$item_meta[ $key ]->label = $values->display_key;
				unset( $item_meta[ $key ]->display_key );
				unset( $item_meta[ $key ]->display_value );
			}

			$line_item = array(
				'id'           => $item_id,
				'subtotal'     => wc_format_decimal( $order->get_line_subtotal( $item, false, false ), $dp ),
				'subtotal_tax' => wc_format_decimal( $item->get_subtotal_tax(), $dp ),
				'total'        => wc_format_decimal( $order->get_line_total( $item, false, false ), $dp ),
				'total_tax'    => wc_format_decimal( $item->get_total_tax(), $dp ),
				'price'        => wc_format_decimal( $order->get_item_total( $item, false, false ), $dp ),
				'quantity'     => $item->get_quantity(),
				'tax_class'    => $item->get_tax_class(),
				'name'         => $item->get_name(),
				'product_id'   => $item->get_variation_id() ? $item->get_variation_id() : $item->get_product_id(),
				'sku'          => is_object( $product ) ? $product->get_sku() : null,
				'meta_data'         => array_values( $item_meta ),
			);

			if ( in_array( 'products', $expand ) && is_object( $product ) ) {
				$_product_data = WC()->api->WC_API_Products->get_product( $product->get_id() );

				if ( isset( $_product_data['product'] ) ) {
					$line_item['product_data'] = $_product_data['product'];
				}
			}

			$order_data['line_items'][] = $line_item;
		}

		// Add shipping.
		foreach ( $order->get_shipping_methods() as $shipping_item_id => $shipping_item ) {
			$order_data['shipping_lines'][] = array(
				'id'           => $shipping_item_id,
				'method_id'    => $shipping_item->get_method_id(),
				'method_title' => $shipping_item->get_name(),
				'total'        => wc_format_decimal( $shipping_item->get_total(), $dp ),
			);
		}

		// Add taxes.
		foreach ( $order->get_tax_totals() as $tax_code => $tax ) {
			$tax_line = array(
				'id'       => $tax->id,
				'rate_id'  => $tax->rate_id,
				'code'     => $tax_code,
				'title'    => $tax->label,
				'total'    => wc_format_decimal( $tax->amount, $dp ),
				'compound' => (bool) $tax->is_compound,
			);

			if ( in_array( 'taxes', $expand ) ) {
				$_rate_data = WC()->api->WC_API_Taxes->get_tax( $tax->rate_id );

				if ( isset( $_rate_data['tax'] ) ) {
					$tax_line['rate_data'] = $_rate_data['tax'];
				}
			}

			$order_data['tax_lines'][] = $tax_line;
		}

		// Add fees.
		foreach ( $order->get_fees() as $fee_item_id => $fee_item ) {
			$order_data['fee_lines'][] = array(
				'id'        => $fee_item_id,
				'title'     => $fee_item->get_name(),
				'tax_class' => $fee_item->get_tax_class(),
				'total'     => wc_format_decimal( $order->get_line_total( $fee_item ), $dp ),
				'total_tax' => wc_format_decimal( $order->get_line_tax( $fee_item ), $dp ),
			);
		}

		// Add coupons.
		foreach ( $order->get_items( 'coupon' ) as $coupon_item_id => $coupon_item ) {
			$coupon_line = array(
				'id'     => $coupon_item_id,
				'code'   => $coupon_item->get_code(),
				'amount' => wc_format_decimal( $coupon_item->get_discount(), $dp ),
			);

			if ( in_array( 'coupons', $expand ) ) {
				$_coupon_data = WC()->api->WC_API_Coupons->get_coupon_by_code( $coupon_item->get_code() );

				if ( ! is_wp_error( $_coupon_data ) && isset( $_coupon_data['coupon'] ) ) {
					$coupon_line['coupon_data'] = $_coupon_data['coupon'];
				}
			}

			$order_data['coupon_lines'][] = $coupon_line;
		}
        // Search.
		
		return array( 'order' => apply_filters( 'woocommerce_api_order_response', $order_data, $order, $fields, $this->server ) );
	}
    protected function query_orders( $args ) {

		// set base query arguments
		$query_args = array(
			'fields'      => 'ids',
            'author__in'  =>$this->author,
			'post_type'   => $this->post_type,
			'post_status' => array_keys( wc_get_order_statuses() ),
		);

		// add status argument
		if ( ! empty( $args['status'] ) ) {
			$statuses                  = 'wc-' . str_replace( ',', ',wc-', $args['status'] );
			$statuses                  = explode( ',', $statuses );
			$query_args['post_status'] = $statuses;

			unset( $args['status'] );
		}

		if ( ! empty( $args['customer_id'] ) ) {
			$query_args['meta_query'] = array(
				array(
					'key'     => '_customer_user',
					'value'   => absint( $args['customer_id'] ),
					'compare' => '=',
				),
			);
		}        

		if ( ! empty( $args['filter_orders_type'] ) ) {            
			$order_type_query = array(
				array(
					'key'     => '_foodsearch_order_type',
					'value'   => $args['filter_orders_type'],
					'compare' => '=',
				),
			);
            if(isset($query_args['meta_query']) && is_array($query_args['meta_query'])){
                array_merge($query_args['meta_query'],$order_type_query);
            }
            else{
                $query_args['meta_query'] = $order_type_query;
            }

		}
		$query_args = $this->merge_query_args( $query_args, $args );
        // echo '<pre>'.print_r($query_args,true).'</pre>';
        // exit();
		return new WP_Query( $query_args );
	}
    protected function merge_query_args( $base_args, $request_args ) {

		$args = array();

		// date
		if ( ! empty( $request_args['after'] ) || ! empty( $request_args['before'] ) || ! empty( $request_args['updated_at_min'] ) || ! empty( $request_args['updated_at_max'] ) ) {

			$args['date_query'] = array();

			//resources created after specified date
			if ( ! empty( $request_args['after'] ) ) {
				$args['date_query'][] = array( 'column' => 'post_date_gmt', 'after' => $this->parse_datetime( $request_args['after'] ), 'inclusive' => true );
			}

			// resources created before specified date
			if ( ! empty( $request_args['before'] ) ) {
				$args['date_query'][] = array( 'column' => 'post_date_gmt', 'before' => $this->parse_datetime( $request_args['before'] ), 'inclusive' => true );
			}

			// resources updated after specified date
			if ( ! empty( $request_args['updated_at_min'] ) ) {
				$args['date_query'][] = array( 'column' => 'post_modified_gmt', 'after' => $this->parse_datetime( $request_args['updated_at_min'] ), 'inclusive' => true );
			}

			// resources updated before specified date
			if ( ! empty( $request_args['updated_at_max'] ) ) {
				$args['date_query'][] = array( 'column' => 'post_modified_gmt', 'before' => $this->parse_datetime( $request_args['updated_at_max'] ), 'inclusive' => true );
			}
		}
        
		// search
		if ( ! empty( $request_args['q'] ) ) {
			$args['s'] = $request_args['q'];
		}

		// resources per response
		if ( ! empty( $request_args['limit'] ) ) {
			$args['posts_per_page'] = $request_args['limit'];
		}

		// resource offset
		if ( ! empty( $request_args['offset'] ) ) {
			$args['offset'] = $request_args['offset'];
		}

		// resource page
		$args['paged'] = ( isset( $request_args['page'] ) ) ? absint( $request_args['page'] ) : 1;

		return array_merge( $base_args, $args );
	}
    protected function validate_request( $id, $type, $context ) {

		if ( 'shop_order' === $type || 'shop_coupon' === $type ) {
			$resource_name = str_replace( 'shop_', '', $type );
		} else {
			$resource_name = $type;
		}

		$id = absint( $id );

		// validate ID
		if ( empty( $id ) ) {
			return new WP_Error( "woocommerce_api_invalid_{$resource_name}_id", sprintf( __( 'Invalid %s ID', 'woocommerce' ), $type ), array( 'status' => 404 ) );
		}

		// only custom post types have per-post type/permission checks
		if ( 'customer' !== $type ) {

			$post = get_post( $id );

			// for checking permissions, product variations are the same as the product post type
			$post_type = ( 'product_variation' === $post->post_type ) ? 'product' : $post->post_type;

			// validate post type
			if ( $type !== $post_type ) {
				return new WP_Error( "woocommerce_api_invalid_{$resource_name}", sprintf( __( 'Invalid %s', 'woocommerce' ), $resource_name ), array( 'status' => 404 ) );
			}

			// validate permissions
			switch ( $context ) {

				case 'read':
					if ( ! $this->is_readable( $post ) ) {
						return new WP_Error( "woocommerce_api_user_cannot_read_{$resource_name}", sprintf( __( 'You do not have permission to read this %s', 'woocommerce' ), $resource_name ), array( 'status' => 401 ) );
					}
					break;

				case 'edit':
					if ( ! $this->is_editable( $post ) ) {
						return new WP_Error( "woocommerce_api_user_cannot_edit_{$resource_name}", sprintf( __( 'You do not have permission to edit this %s', 'woocommerce' ), $resource_name ), array( 'status' => 401 ) );
					}
					break;

				case 'delete':
					if ( ! $this->is_deletable( $post ) ) {
						return new WP_Error( "woocommerce_api_user_cannot_delete_{$resource_name}", sprintf( __( 'You do not have permission to delete this %s', 'woocommerce' ), $resource_name ), array( 'status' => 401 ) );
					}
					break;
			}
		}

		return $id;
	}
    public function format_datetime( $timestamp, $convert_to_utc = false, $convert_to_gmt = false ) {
        if ( $convert_to_gmt ) {
            if ( is_numeric( $timestamp ) ) {
                $timestamp = date( 'Y-m-d H:i:s', $timestamp );
            }
    
            $timestamp = get_gmt_from_date( $timestamp );
        }
    
        if ( $convert_to_utc ) {
            $timezone = new DateTimeZone( wc_timezone_string() );
        } else {
            $timezone = new DateTimeZone( 'UTC' );
        }
    
        try {
    
            if ( is_numeric( $timestamp ) ) {
                $date = new DateTime( "@{$timestamp}" );
            } else {
                $date = new DateTime( $timestamp, $timezone );
            }
    
            // convert to UTC by adjusting the time based on the offset of the site's timezone
            if ( $convert_to_utc ) {
                $date->modify( -1 * $date->getOffset() . ' seconds' );
            }
        } catch ( Exception $e ) {
    
            $date = new DateTime( '@0' );
        }
    
        return $date->format( 'Y-m-d\TH:i:s\Z' );
    }
    public function parse_datetime( $datetime ) {

        // Strip millisecond precision (a full stop followed by one or more digits)
        if ( strpos( $datetime, '.' ) !== false ) {
            $datetime = preg_replace( '/\.\d+/', '', $datetime );
        }
    
        // default timezone to UTC
        $datetime = preg_replace( '/[+-]\d+:+\d+$/', '+00:00', $datetime );
    
        try {
    
            $datetime = new DateTime( $datetime, new DateTimeZone( 'UTC' ) );
    
        } catch ( Exception $e ) {
    
            $datetime = new DateTime( '@0' );
    
        }
    
        return $datetime->format( 'Y-m-d H:i:s' );
    }
    public function get_order_statuses() {

		$order_statuses = array();

		foreach ( wc_get_order_statuses() as $slug => $name ) {
			$order_statuses[ str_replace( 'wc-', '', $slug ) ] = $name;
		}

		return array( 'order_statuses' => apply_filters( 'woocommerce_api_order_statuses_response', $order_statuses, $this ) );
	}
    public function get_orders_count( $status = null, $filter = array() ) {

		

			if ( ! empty( $status ) ) {

				if ( 'any' === $status ) {

					$order_statuses = array();

					foreach ( wc_get_order_statuses() as $slug => $name ) {
						$filter['status'] = str_replace( 'wc-', '', $slug );
						$query = $this->query_orders( $filter );
						$order_statuses[ str_replace( 'wc-', '', $slug ) ] = (int) $query->found_posts;
					}

					return array( 'count' => $order_statuses );

				} else {
					$filter['status'] = $status;
				}
			}

			$query = $this->query_orders( $filter );

			return array( 'count' => (int) $query->found_posts );

		
	}

    
}
new resturant_Orders;