<?php

namespace FoodSearch\Dashboard;

class templates {

    public $templates;

    public function __construct() {
        $this->templates = array();
        add_filter('theme_page_templates', array($this, 'custom_page_templates'), 10, 1);
        add_filter('template_include', array($this, 'template_include'));
        add_action('init', array($this, 'templates_list'), 5);
    }

    public function templates_list() {
        $all_templates = array(
            'foodsearch-full-page.php' => esc_html__('foodsearch full page', 'wp-foodsearch'),
        );
        $this->templates = apply_filters('bakyard_templates_list_set', $all_templates);
    }

    public function custom_page_templates($post_templates) {
        $post_templates = array_merge($this->templates, $post_templates);
        return $post_templates;
    }

    public function template_include($template) {
        global $post;
        if (!isset($post)) {
            return $template;
        }
        if (!isset($this->templates[get_post_meta($post->ID, '_wp_page_template', true)])) {
            return $template;
        }
        if ('foodsearch-full-page.php' === get_post_meta($post->ID, '_wp_page_template', true)) {

            $file = foodsearch_plugin_get_path('templates/' . get_post_meta($post->ID, '_wp_page_template', true));
            if (file_exists($file)) {
                return $file;
            }
        }
        return apply_filters('foodsearch_template_page_file', $template);
    }

}

new templates;
