<?php

namespace FoodSearch\User_Forms;
use FoodSearch\User_Forms\Submit_Form;

class Common_Functions {
    
    public function __construct() {
        if (!empty($_REQUEST['fds_action'])) {
            add_action('wp_loaded', array($this, 'process_ajax'), 9);
        }
    }
    
    public function form_submit_terms($place = '') {
        $rand_num = rand(10000000, 99999999);
        $privcy_page_id = get_option('wp_page_for_privacy_policy');
        if ($privcy_page_id > 0) {
            $policy_page_url = get_permalink($privcy_page_id);
            $policy_page_title = get_the_title($privcy_page_id);

            ob_start();
            if ($place == 'checkout') {
                ?>
                <div class="terms-priv-chek-con">
                    <span><?php echo wp_kses(sprintf(__('by placing order you\'re consenting to our <a href="%s" class="fds-link">%s</a>', 'wp-foodsearch'), $policy_page_url, $policy_page_title), array('a' => array('href' => array(), 'target' => array(), 'title' => array()))) ?></span>
                </div>
                <?php
            } else {
                ?>
                <div class="terms-priv-chek-con fds-checkfield-con">
                    <label for="terms-<?php echo absint($rand_num) ?>" class="fds-input-label">
                        <input id="terms-<?php echo absint($rand_num) ?>" type="checkbox" name="terms_cond_check" required=""> <span><?php echo wp_kses(sprintf(__('by clicking checkbox, you agree to our <a href="%s" class="fds-link">%s</a>', 'wp-foodsearch'), $policy_page_url, $policy_page_title), array('a' => array('href' => array(), 'target' => array(), 'title' => array()))) ?></span>
                    </label>
                </div>
                <?php
            }
            $terms_con = ob_get_clean();
            echo apply_filters('foodsearch_terms_conditions_html', $terms_con, $place);
        }
    }
    
    public function process_ajax() {

        $submit_obj = new Submit_Form;
        add_action('wp_ajax_nopriv_foodsearch_user_register_action', array($submit_obj, 'signup'));
        add_action('wp_ajax_nopriv_foodsearch_user_login_action', array($submit_obj, 'login'));
        add_action('wp_ajax_nopriv_foodsearch_user_forgotpass_action', array($submit_obj, 'forgot_pass'));
        
        add_action('wp_ajax_nopriv_foodsearch_user_resetpass_action', array($submit_obj, 'reset_pass'));

        if ( !empty($_REQUEST['fds_action']) ) {
            $ajax_action = sanitize_key($_REQUEST['fds_action']);

            define("FOODSEARCH_IS_AJAX", true);

            do_action( 'wp_ajax_nopriv_' . $ajax_action );
            die();
        }
    }

}

new Common_Functions;
