const { Button, ButtonGroup, PanelRow, SelectControl, RangeControl, ColorPicker } = wp.components;
const { MediaUpload, MediaUploadCheck } = wp.blockEditor;
const { __ } = wp.i18n;
import { useState } from '@wordpress/element';
import { __experimentalNumberControl as NumberControl } from '@wordpress/components';
import OutsideClickHandler from 'react-outside-click-handler';

export const Background = (props) => {
    const { setAttributes } = props;
    const [isColor1, setColor1] = useState(false);
    const [isColor2, setColor2] = useState(false);
    const [isSrcRes, setSrcRes] = useState("lg");
    const [isPosRes, setPosRes] = useState("lg");
    const [isRepeatRes, setRepeatRes] = useState("lg");
    const [isSizeRes, setSizeRes] = useState("lg");
    var name = props.name;

    var arr = {
        "bgType":"",
        "color1":{"r":'', "g":'', "b":'', "a":''},
        "location1":"",
        "color2":{"r":'', "g":'', "b":'', "a":''},
        "location2":"",
        "gradType":"",
        "angle":"",
        "position":"",
        "img":{
          "src":{"lg":'', "md":'', "sm":'', "xs":''},
          "pos":{"lg":'', "md":'', "sm":'', "xs":''},
          "xpos":{"lg":'', "lgUnit":'', "md":'', "mdUnit":'', "sm":'', "smUnit":'', "xs":'', "xsUnit":'' },
          "ypos":{"lg":'', "lgUnit":'', "md":'', "mdUnit":'', "sm":'', "smUnit":'', "xs":'', "xsUnit":'' },
          "attach":'', 
          "repeat":{"lg":'', "md":'', "sm":'', "xs":''},
          "size":{"lg":'', "md":'', "sm":'', "xs":''},
          "width":{"lg":'', "lgUnit":'', "md":'', "mdUnit":'', "sm":'', "smUnit":'', "xs":'', "xsUnit":'' },
        },
    };

    const prepare_val = (index1, index2, index3, val) => {
        arr.bgType = props.attr.bgType;
        arr.color1 = props.attr.color1;
        arr.location1 = props.attr.location1;
        arr.color2 = props.attr.color2;
        arr.location2 = props.attr.location2;
        arr.gradType = props.attr.gradType;
        arr.angle = props.attr.angle;
        arr.position = props.attr.position;
          arr.img.src.lg = props.attr.img.src.lg;
          arr.img.src.md = props.attr.img.src.md;
          arr.img.src.sm = props.attr.img.src.sm;
          arr.img.src.xs = props.attr.img.src.xs;
        arr.img.pos.lg = props.attr.img.pos.lg;
        arr.img.pos.md = props.attr.img.pos.md;
        arr.img.pos.sm = props.attr.img.pos.sm;
        arr.img.pos.xs = props.attr.img.pos.xs;
          arr.img.xpos.lg = props.attr.img.xpos.lg;
          arr.img.xpos.lgUnit = props.attr.img.xpos.lgUnit;
          arr.img.xpos.md = props.attr.img.xpos.md;
          arr.img.xpos.mdUnit = props.attr.img.xpos.mdUnit;
          arr.img.xpos.sm = props.attr.img.xpos.sm;
          arr.img.xpos.smUnit = props.attr.img.xpos.smUnit;
          arr.img.xpos.xs = props.attr.img.xpos.xs;
          arr.img.xpos.xsUnit = props.attr.img.xpos.xsUnit;
        arr.img.ypos.lg = props.attr.img.ypos.lg;
        arr.img.ypos.lgUnit = props.attr.img.ypos.lgUnit;
        arr.img.ypos.md = props.attr.img.ypos.md;
        arr.img.ypos.mdUnit = props.attr.img.ypos.mdUnit;
        arr.img.ypos.sm = props.attr.img.ypos.sm;
        arr.img.ypos.smUnit = props.attr.img.ypos.smUnit;
        arr.img.ypos.xs = props.attr.img.ypos.xs;
        arr.img.ypos.xsUnit = props.attr.img.ypos.xsUnit;

        arr.img.attach = props.attr.img.attach;
        arr.img.repeat.lg = props.attr.img.repeat.lg;
          arr.img.repeat.lg = props.attr.img.repeat.lg;
          arr.img.repeat.md = props.attr.img.repeat.md;
          arr.img.repeat.sm = props.attr.img.repeat.sm;
          arr.img.repeat.xs = props.attr.img.repeat.xs;
        arr.img.size.lg = props.attr.img.size.lg;
        arr.img.size.md = props.attr.img.size.md;
        arr.img.size.sm = props.attr.img.size.sm;
        arr.img.size.xs = props.attr.img.size.xs;
          arr.img.width.lg = props.attr.img.width.lg;
          arr.img.width.lgUnit = props.attr.img.width.lgUnit;
          arr.img.width.md = props.attr.img.width.md;
          arr.img.width.mdUnit = props.attr.img.width.mdUnit;
          arr.img.width.sm = props.attr.img.width.sm;
          arr.img.width.smUnit = props.attr.img.width.smUnit;
          arr.img.width.xs = props.attr.img.width.xs;
          arr.img.width.xsUnit = props.attr.img.width.xsUnit;

        if (index2 == "" && index3 == "") arr[index1] = val;
        else if (index3 == "") arr[index1][index2] = val;
        else arr[index1][index2][index3] = val;

        setAttributes( {[name]:arr} );
    }

    function foodsearch_cssMount() {
        var bg, imgpos, imgsize;
        if ( props.attr.bgType === "classic" ) {
          bg = `background: rgba(` + props.attr.color1.r + `, ` + props.attr.color1.g + `, ` + props.attr.color1.b + `, ` + props.attr.color1.a + `);` ;
          bg += `background-image: url('` + props.attr.img.src.lg + `');` ;
            if ( props.attr.img.pos.lg === "custom" ) {
                imgpos = props.attr.img.xpos.lg + props.attr.img.xpos.lgUnit + " " + props.attr.img.ypos.lg + props.attr.img.ypos.lgUnit;
            }
            else imgpos = props.attr.img.pos.lg;
            if ( props.attr.img.size.lg === "custom" ) {
                imgsize = props.attr.img.width.lg + props.attr.img.width.lgUnit + " auto" ;
            }
            else imgsize = props.attr.img.size.lg;

        }
        else if ( props.attr.bgType === "gradient" ) {
            if ( props.attr.gradType === "linear" ){
                bg = `background: linear-gradient(` + props.attr.angle  + `deg, rgba(` + props.attr.color1.r + `, ` + props.attr.color1.g + `, ` + props.attr.color1.b + `, ` + props.attr.color1.a + `) ` + props.attr.location1 + `% `  + `, rgba(` + props.attr.color2.r + `, ` + props.attr.color2.g + `, ` + props.attr.color2.b + `, ` + props.attr.color2.a + `) ` + props.attr.location2 + `%`  + `);`;
            }
            else if ( props.attr.gradType === "radial" ) {
                bg = `background: radial-gradient(at ` + props.attr.position  + `, rgba(` + props.attr.color1.r + `, ` + props.attr.color1.g + `, ` + props.attr.color1.b + `, ` + props.attr.color1.a + `) ` + props.attr.location1 + `% `  + `, rgba(` + props.attr.color2.r + `, ` + props.attr.color2.g + `, ` + props.attr.color2.b + `, ` + props.attr.color2.a + `) ` + props.attr.location2 + `%`  + `);`;
            }
        }
        var css = `
            #fds-block-` + props.block_id + ` .` + props.class + ` {
                ` + bg + `
                background-position: ` + imgpos + `;
                background-attachment: ` + props.attr.img.attach + `;
                background-repeat: ` + props.attr.img.repeat.lg + `;
                background-size: ` + imgsize + `;
            }
            .` + props.name + `1 {
              ` + `background: rgba(` + props.attr.color1.r + `, ` + props.attr.color1.g + `, ` + props.attr.color1.b + `, ` + props.attr.color1.a + `) ;
            }
            .` + props.name + `2 {
              ` + `background: rgba(` + props.attr.color2.r + `, ` + props.attr.color2.g + `, ` + props.attr.color2.b + `, ` + props.attr.color2.a + `) ;
            }
        `;
        var elem = document.getElementById('res-listing-' + props.block_id );
        elem.innerHTML = elem.innerHTML + css;
    }
    function foodsearch_html_src(val){
      return (
        <>
          <div className='fds-bg-thumb' style={{ background: "url('" + props.attr.img.src[val] + "') no-repeat center " }}></div>
          <MediaUpload
                onSelect={ (newval) => { prepare_val("img", "src", val, newval.url) }}
                render={ ( { open } ) => (
                    <>
                    <Button className="fds-bg-thumb-btn" onClick={ open } > { 'Background Image' } </Button>
                    { props.attr.img.src[val] &&
                        <Button className="fds-bg-trash-btn" icon="dashicons dashicons-trash" onClick= { () => { prepare_val("img", "src", val, "") }} ></Button>
                    }
                    </>
                ) }
          />
        </>
      )
    }
    function foodsearch_html_pos(val){
      return (
        <SelectControl onChange={ ( newval ) => { prepare_val("img", "pos", val, newval) }} value={props.attr.img.pos[val]}
          options={ [
              { label: 'Default', value: '' },
              { label: 'Center Center', value: 'center center' },
              { label: 'Center Left', value: 'center left' },
              { label: 'Center Right', value: 'center right' },
              { label: 'Top Center', value: 'top center' },
              { label: 'Top Left', value: 'top left' },
              { label: 'Top Right', value: 'top right' },
              { label: 'Bottom Center', value: 'bottom center' },
              { label: 'Bottom Left', value: 'bottom left' },
              { label: 'Bottom Right', value: 'bottom right' },
              { label: 'Custom', value: 'custom' },
          ] }
        />
      )
    }
    function foodsearch_html_repeat(val){
      return (
        <SelectControl onChange={ ( newval ) => { prepare_val("img", "repeat", val, newval) }} value={props.attr.img.repeat[val]}
          options={ [
              { label: 'Default', value: '' },
              { label: 'No-Repeat', value: 'no-repeat' },
              { label: 'Repeat', value: 'repeat' },
              { label: 'Repeat-X', value: 'repeat-x' },
              { label: 'Repeat-Y', value: 'repeat-y' },
          ] }
        />
      )
    }
    function foodsearch_html_size(val){
      return (
        <SelectControl onChange={ ( newval ) => { prepare_val("img", "size", val, newval) }} value={props.attr.img.size[val]}
          options={ [
              { label: 'Default', value: '' },
              { label: 'Auto', value: 'auto' },
              { label: 'Cover', value: 'cover' },
              { label: 'Contain', value: 'contain' },
              { label: 'Custom', value: 'custom' },
          ] }
        />
      )
    }
    function foodsearch_html_custom_size(val, val_unit){
      return (
        <div className="responsive-row">
          <div className="fds-res-control">Width:</div>
          <div className="fds-res-control">
              <ButtonGroup className="fds-res-unit">
                  <Button variant="tertiary" label="Pixel" className={props.attr.img.width[val_unit] == "px" ? "active" : ""} onClick={() => ( prepare_val("img", "width", val_unit, "px") )} >PX</Button>
                  <Button variant="tertiary" label="EM" className={props.attr.img.width[val_unit] == "em" ? "active" : ""} onClick={() => ( prepare_val("img", "width", val_unit, "em") )} >EM</Button>
                  <Button variant="tertiary" label="Percent" className={props.attr.img.width[val_unit] == "%" ? "active" : ""} onClick={() => ( prepare_val("img", "width", val_unit, "%") )} >%</Button>
              </ButtonGroup>
          </div>
          <RangeControl className="range-control" min={ 0 } max={ 1000 }
              value={ props.attr.img.width[val] }
              onChange={ ( newval ) => { prepare_val("img", "width", val, newval) }}
          />
        </div>
      )
    }
    function foodsearch_html_custom_pos(val, val_unit){
      return (
        <>
          <div className="responsive-row">
              <div className="fds-res-control">X Position:</div>
              <div className="fds-res-control">
                  <ButtonGroup className="fds-res-unit">
                      <Button variant="tertiary" label="Pixel" className={props.attr.img.xpos[val_unit] == "px" ? "active" : ""} onClick={() => ( prepare_val("img", "xpos", val_unit, "px") )} >PX</Button>
                      <Button variant="tertiary" label="EM" className={props.attr.img.xpos[val_unit] == "em" ? "active" : ""} onClick={() => ( prepare_val("img", "xpos", val_unit, "em") )} >EM</Button>
                      <Button variant="tertiary" label="Percent" className={props.attr.img.xpos[val_unit] == "%" ? "active" : ""} onClick={() => ( prepare_val("img", "xpos", val_unit, "%") )} >%</Button>
                  </ButtonGroup>
              </div>
              <RangeControl className="range-control" min={ -800 } max={ 800 }
                  value={ props.attr.img.xpos[val] }
                  onChange={ ( newval ) => { prepare_val("img", "xpos", val, newval) }}
              />
          </div>
          <div className="responsive-row">
              <div className="fds-res-control">Y Position:</div>
              <div className="fds-res-control">
                  <ButtonGroup className="fds-res-unit">
                      <Button variant="tertiary" label="Pixel" className={props.attr.img.ypos[val_unit] == "px" ? "active" : ""} onClick={() => ( prepare_val("img", "ypos", val_unit, "px") )} >PX</Button>
                      <Button variant="tertiary" label="EM" className={props.attr.img.ypos[val_unit] == "em" ? "active" : ""} onClick={() => ( prepare_val("img", "ypos", val_unit, "em") )} >EM</Button>
                      <Button variant="tertiary" label="Percent" className={props.attr.img.ypos[val_unit] == "%" ? "active" : ""} onClick={() => ( prepare_val("img", "ypos", val_unit, "%") )} >%</Button>
                  </ButtonGroup>
              </div>
              <RangeControl className="range-control" min={ -800 } max={ 800 }
                  value={ props.attr.img.ypos[val] }
                  onChange={ ( newval ) => { prepare_val("img", "ypos", val, newval) }}
              />
          </div>
        </>
      )
    }
    
    return (
        <div className="responsive-row">
            <div className='fds-option-component'>
                <SelectControl label={__( 'background type', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("bgType", "", "", newval) }} value={props.attr.bgType}
                    options={ [
                        { label: 'Classic', value: 'classic' },
                        { label: 'Gradient', value: 'gradient' },
                    ] }
                />
            </div>
            <div className="fds-main-popup">
                <span className='fds-color-title'>{__( 'color 1', 'wp-foodsearch' )}</span>
                <div className='fds-reset-color'>
                  { props.attr.color1.r !== "" && 
                    <Button label="Reset" icon="dashicons dashicons-image-rotate" onClick={() => ( prepare_val("color1", "", "", arr.color1) )} ></Button>
                  }
                  <OutsideClickHandler onOutsideClick={() => { setColor1(false) }} >
                      <div className='fds-color-btn'><Button className={props.name + 1} label="Color" onClick={() => ( setColor1(!isColor1) )} ></Button></div>
                      { isColor1 === true && 
                          <ColorPicker 
                            color={`rgba(` + props.attr.color1.r + `, ` + props.attr.color1.g + `, ` + props.attr.color1.b + `, ` + props.attr.color1.a + `)`}
                            onChangeComplete={(newval) => prepare_val("color1", "", "", newval.rgb)} 
                          />
                      }
                  </OutsideClickHandler>
                </div>
            </div>
            {props.attr.bgType === "gradient" && 
                <>
                <div className="responsive-row">
                    <div className="fds-res-control">{__( 'location 1', 'wp-foodsearch' )}</div>
                    <RangeControl className="range-control" min={ 1 } max={ 100 }
                        value={ props.attr.location1 }
                        onChange={ ( newval ) => { prepare_val("location1", "", "", newval) }}
                    />
                </div>
                <div className="fds-main-popup">
                    <span className='fds-color-title'>{__( 'color 2', 'wp-foodsearch' )}</span>
                    <div className='fds-reset-color'>
                      { props.attr.color2.r !== "" && 
                        <Button label="Reset" icon="dashicons dashicons-image-rotate" onClick={() => ( prepare_val("color2", "", "", arr.color2) )} ></Button>
                      }
                      <OutsideClickHandler onOutsideClick={() => { setColor2(false) }} >
                          <div className='fds-color-btn'><Button className={props.name + 2} label="Color 2" onClick={() => ( setColor2(!isColor2) )} ></Button></div>
                          { isColor2 === true && 
                              <ColorPicker 
                                color={`rgba(` + props.attr.color2.r + `, ` + props.attr.color2.g + `, ` + props.attr.color2.b + `, ` + props.attr.color2.a + `)`}
                                onChangeComplete={(newval) => prepare_val("color2", "", "", newval.rgb)} 
                              />
                          }
                      </OutsideClickHandler>
                    </div>
                </div>
                <div className="responsive-row">
                    <div className="fds-res-control">{__( 'location 2', 'wp-foodsearch' )}</div>
                    <RangeControl className="range-control" min={ 1 } max={ 100 }
                        value={ props.attr.location2 }
                        onChange={ ( newval ) => { prepare_val("location2", "", "", newval) }}
                    />
                </div>
                <div className='fds-option-component'>
                    <SelectControl label={__( 'type', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("gradType", "", "", newval) }} value={props.attr.gradType}
                        options={ [
                            { label: 'Linear', value: 'linear' },
                            { label: 'Radial', value: 'radial' },
                        ] }
                    />
                </div>
                {props.attr.gradType === "linear" && 
                    <div className="responsive-row">
                        <div className="fds-res-control">{__( 'angle', 'wp-foodsearch' )}</div>
                        <RangeControl className="range-control" min={ 0 } max={ 360 }
                            value={ props.attr.angle }
                            onChange={ ( newval ) => { prepare_val("angle", "", "", newval) }}
                        />
                    </div>
                }
                {props.attr.gradType === "radial" && 
                    <div className='fds-option-component'>
                        <SelectControl label={__( 'position', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("position", "", "", newval) }} value={props.attr.position}
                            options={ [
                                { label: 'Center Center', value: 'center center' },
                                { label: 'Center Left', value: 'center left' },
                                { label: 'Center Right', value: 'center right' },
                                { label: 'Top Center', value: 'top center' },
                                { label: 'Top Left', value: 'top left' },
                                { label: 'Top Right', value: 'top right' },
                                { label: 'Bottom Center', value: 'bottom center' },
                                { label: 'Bottom Left', value: 'bottom left' },
                                { label: 'Bottom Right', value: 'bottom right' },
                            ] }
                        />
                    </div>
                }

                </>
            }
            {props.attr.bgType === "classic" && 
                <>
                <div className="fds-res-control">
                {__( 'image', 'wp-foodsearch' )} 
                    {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isSrcRes === "lg" ? "active" : ""} onClick={() => ( setSrcRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isSrcRes === "md" ? "active" : ""} onClick={() => ( setSrcRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isSrcRes === "sm" ? "active" : ""} onClick={() => ( setSrcRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isSrcRes === "xs" ? "active" : ""} onClick={() => ( setSrcRes("xs") )} ></Button>
                        </ButtonGroup>
                    }
                </div>
                <div className="fds-bg-panel">
                  <MediaUploadCheck>
                    {isSrcRes === "lg" && foodsearch_html_src("lg") }
                    {isSrcRes === "md" && foodsearch_html_src("md") }
                    {isSrcRes === "sm" && foodsearch_html_src("sm") }
                    {isSrcRes === "xs" && foodsearch_html_src("xs") }
                  </MediaUploadCheck>
                </div>
                <div className='fds-option-component'>
                    <div className="fds-res-control">
                    {__( 'position', 'wp-foodsearch' )}
                      {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isPosRes === "lg" ? "active" : ""} onClick={() => ( setPosRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isPosRes === "md" ? "active" : ""} onClick={() => ( setPosRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isPosRes === "sm" ? "active" : ""} onClick={() => ( setPosRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isPosRes === "xs" ? "active" : ""} onClick={() => ( setPosRes("xs") )} ></Button>
                        </ButtonGroup>
                      }
                    </div>
                    {isPosRes === "lg" && foodsearch_html_pos("lg") }
                    {isPosRes === "md" && foodsearch_html_pos("md") }
                    {isPosRes === "sm" && foodsearch_html_pos("sm") }
                    {isPosRes === "xs" && foodsearch_html_pos("xs") }
                </div>
                { ( isPosRes === "lg" && props.attr.img.pos.lg === "custom") && 
                  foodsearch_html_custom_pos("lg", "lgUnit")
                }
                { ( isPosRes === "md" && props.attr.img.pos.md === "custom") && 
                  foodsearch_html_custom_pos("md", "mdUnit")
                }
                { ( isPosRes === "sm" && props.attr.img.pos.sm === "custom") && 
                  foodsearch_html_custom_pos("sm", "smUnit")
                }
                { ( isPosRes === "xs" && props.attr.img.pos.xs === "custom") && 
                  foodsearch_html_custom_pos("xs", "xsUnit")
                }
                <div className='fds-option-component'>
                    <SelectControl label={__( 'attachment', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("img", "attach", "", newval) }} value={props.attr.img.attach}
                        options={ [
                            { label: 'Default', value: '' },
                            { label: 'Scroll', value: 'scroll' },
                            { label: 'Fixed', value: 'fixed' },
                        ] }
                    />
                </div>
                <div className='fds-option-component'>
                    <div className="fds-res-control">
                    {__( 'repeat', 'wp-foodsearch' )} 
                      {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isRepeatRes === "lg" ? "active" : ""} onClick={() => ( setRepeatRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isRepeatRes === "md" ? "active" : ""} onClick={() => ( setRepeatRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isRepeatRes === "sm" ? "active" : ""} onClick={() => ( setRepeatRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isRepeatRes === "xs" ? "active" : ""} onClick={() => ( setRepeatRes("xs") )} ></Button>
                        </ButtonGroup>
                      }
                    </div>
                    {isRepeatRes === "lg" && foodsearch_html_repeat("lg") }
                    {isRepeatRes === "md" && foodsearch_html_repeat("md") }
                    {isRepeatRes === "sm" && foodsearch_html_repeat("sm") }
                    {isRepeatRes === "xs" && foodsearch_html_repeat("xs") }
                </div>
                <div className='fds-option-component'>
                    <div className="fds-res-control">
                    {__( 'size', 'wp-foodsearch' )} 
                      {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isSizeRes === "lg" ? "active" : ""} onClick={() => ( setSizeRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isSizeRes === "md" ? "active" : ""} onClick={() => ( setSizeRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isSizeRes === "sm" ? "active" : ""} onClick={() => ( setSizeRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isSizeRes === "xs" ? "active" : ""} onClick={() => ( setSizeRes("xs") )} ></Button>
                        </ButtonGroup>
                      }
                    </div>
                    {isSizeRes === "lg" && foodsearch_html_size("lg") }
                    {isSizeRes === "md" && foodsearch_html_size("md") }
                    {isSizeRes === "sm" && foodsearch_html_size("sm") }
                    {isSizeRes === "xs" && foodsearch_html_size("xs") }
                </div>
                  { ( isSizeRes === "lg" && props.attr.img.size.lg === "custom") && 
                    foodsearch_html_custom_size("lg", "lgUnit")
                  }
                  { ( isSizeRes === "md" && props.attr.img.size.md === "custom") && 
                    foodsearch_html_custom_size("md", "mdUnit")
                  }
                  { ( isSizeRes === "sm" && props.attr.img.size.sm === "custom") && 
                    foodsearch_html_custom_size("sm", "smUnit")
                  }
                  { ( isSizeRes === "xs" && props.attr.img.size.xs === "custom") && 
                    foodsearch_html_custom_size("xs", "xsUnit")
                  }

                </>
            }

            { foodsearch_cssMount() }
        </div>
)
}

export default Background;