const { Button, ButtonGroup, PanelRow } = wp.components;
const { __ } = wp.i18n;
import { useState } from '@wordpress/element';
import { __experimentalNumberControl as NumberControl } from '@wordpress/components';

export const Padding = (props) => {
    const { setAttributes } = props;
    const [isPaddingRes, setPaddingRes] = useState("lg");
    const [isPaddingLock, setPaddingLock] = useState("false");
    var name = props.name;

    var paddingArr = {
        "lg":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        "md":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        "sm":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        "xs":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
    };

    const prepare_val = (index1, index2, val) => {
        paddingArr.lg.unit = props.attr.lg.unit;
        paddingArr.lg.top = props.attr.lg.top;
        paddingArr.lg.right = props.attr.lg.right;
        paddingArr.lg.bottom = props.attr.lg.bottom;
        paddingArr.lg.left = props.attr.lg.left;
            paddingArr.md.unit = props.attr.md.unit;
            paddingArr.md.top = props.attr.md.top;
            paddingArr.md.right = props.attr.md.right;
            paddingArr.md.bottom = props.attr.md.bottom;
            paddingArr.md.left = props.attr.md.left;
        paddingArr.sm.unit = props.attr.sm.unit;
        paddingArr.sm.top = props.attr.sm.top;
        paddingArr.sm.right = props.attr.sm.right;
        paddingArr.sm.bottom = props.attr.sm.bottom;
        paddingArr.sm.left = props.attr.sm.left;
            paddingArr.xs.unit = props.attr.xs.unit;
            paddingArr.xs.top = props.attr.xs.top;
            paddingArr.xs.right = props.attr.xs.right;
            paddingArr.xs.bottom = props.attr.xs.bottom;
            paddingArr.xs.left = props.attr.xs.left;
    
        paddingArr[index1][index2] = val;

        if ( isPaddingLock && !isNaN(val) ){
            if ( isPaddingRes === "lg" ){
                paddingArr.lg.top = val;
                paddingArr.lg.right = val;
                paddingArr.lg.bottom = val;
                paddingArr.lg.left = val;
            }
            else if ( isPaddingRes === "md" ){
                paddingArr.md.top = val;
                paddingArr.md.right = val;
                paddingArr.md.bottom = val;
                paddingArr.md.left = val;
            }
            else if ( isPaddingRes === "sm" ){
                paddingArr.sm.top = val;
                paddingArr.sm.right = val;
                paddingArr.sm.bottom = val;
                paddingArr.sm.left = val;
            }
            else if ( isPaddingRes === "xs" ){
                paddingArr.xs.top = val;
                paddingArr.xs.right = val;
                paddingArr.xs.bottom = val;
                paddingArr.xs.left = val;
            }
        }
    
        setAttributes( {[name]:paddingArr} );
    }

    function foodsearch_cssMount() {
        var css = `
            #fds-block-` + props.block_id + ` .` + props.class + ` {
                padding: ` + props.attr.lg.top + ((props.attr.lg.top) ? props.attr.lg.unit : "0") + ` ` + props.attr.lg.right + ((props.attr.lg.right) ? props.attr.lg.unit : "0") + ` ` + props.attr.lg.bottom + ((props.attr.lg.bottom) ? props.attr.lg.unit : "0") + ` ` + props.attr.lg.left + ((props.attr.lg.left) ? props.attr.lg.unit : "0") + `;
            }
        `;
        var elem = document.getElementById('res-listing-' + props.block_id );
        elem.innerHTML = elem.innerHTML + css;
    }
    function foodsearch_html(val){
      return (
        <>
        <div className="fds-res-control">
            <ButtonGroup className="fds-res-unit">
                <Button variant="tertiary" label="Pixel" className={props.attr[val].unit == "px" ? "active" : ""} onClick={() => ( prepare_val(val, "unit", "px") )} >PX</Button>
                <Button variant="tertiary" label="EM" className={props.attr[val].unit == "em" ? "active" : ""} onClick={() => ( prepare_val(val, "unit", "em") )} >EM</Button>
                <Button variant="tertiary" label="Percent" className={props.attr[val].unit == "%" ? "active" : ""} onClick={() => ( prepare_val(val, "unit", "%") )} >%</Button>
            </ButtonGroup>
        </div>
        <div className="fds-res-control-input">
            <NumberControl label={__( 'top', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "top", newval) }} value={props.attr[val].top} />
            <NumberControl label={__( 'right', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "right", newval) }} value={props.attr[val].right} />
            <NumberControl label={__( 'bottom', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "bottom", newval) }} value={props.attr[val].bottom} />
            <NumberControl label={__( 'left', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "left", newval) }} value={props.attr[val].left} />
            <ButtonGroup>
                <Button variant="primary" className={isPaddingLock ? "active" : ""} icon={isPaddingLock ? "dashicons dashicons-admin-links" : "dashicons dashicons-admin-links"} onClick={() => ( setPaddingLock(!isPaddingLock) )} ></Button>
            </ButtonGroup>
        </div>
        </>
      )
    }

    return (
            <div className="responsive-row">
                <div className="fds-res-control">
                {__( 'padding', 'wp-foodsearch' )} 
                    {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isPaddingRes === "lg" ? "active" : ""} onClick={() => ( setPaddingRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isPaddingRes === "md" ? "active" : ""} onClick={() => ( setPaddingRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isPaddingRes === "sm" ? "active" : ""} onClick={() => ( setPaddingRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isPaddingRes === "xs" ? "active" : ""} onClick={() => ( setPaddingRes("xs") )} ></Button>
                        </ButtonGroup>
                    }
                </div>
                    {isPaddingRes === "lg" && foodsearch_html("lg") }
                    {isPaddingRes === "md" && foodsearch_html("md") }
                    {isPaddingRes === "sm" && foodsearch_html("sm") }
                    {isPaddingRes === "xs" && foodsearch_html("xs") }
                { foodsearch_cssMount() }
            </div>
    )
}

export default Padding;