jQuery( document ).ready(function() {
  var $see_more = parseInt(jQuery('input[name="see_more"]').val());
  var $offset = $see_more;
  var $cuisine_len = jQuery('.cuisine-type > li').length;

  jQuery(document).on("click", "#cuisine-toggle", function(event) { 
    "use strict";
    if ( jQuery('#cuisine-toggle').html() === "See More" ){
      jQuery('.cuisine-type > li').slice($offset, $offset + $see_more ).fadeIn().css("display", "flex");
      $offset = $offset + $see_more;
      if ( $offset >= $cuisine_len ) {
        jQuery('#cuisine-toggle').html("See Less");
      }
    }
    else if ( jQuery('#cuisine-toggle').html() === "See Less" ){
      jQuery('.cuisine-toggle').fadeOut(200);
      jQuery('#cuisine-toggle').html("See More")
      $offset = $see_more;
    }
    
  });
  
});


jQuery(document).on("click", ".fds-take-away", function(event) { 
  "use strict";
  jQuery('input[name="take_away"]').prop('checked', !(jQuery('input[name="take_away"]').is(':checked')) );
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
});

jQuery(document).on("click", ".fds-delivery-option", function(event) { 
  "use strict";
  jQuery('input[name="delivery"]').prop('checked', !(jQuery('input[name="delivery"]').is(':checked')) );
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
});

jQuery(document).on("click", ".fds-min-order", function(event) { 
  "use strict";
  jQuery('input[name="order"]').filter('[value="minimum-order"]').prop('checked', true );
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
});

jQuery(document).on("click", ".fds-delivery-fee", function(event) { 
  "use strict";
  jQuery('input[name="order"]').filter('[value="minimum-delivery-fee"]').prop('checked', true );
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
});

function foodsearch_cuisine_type(val){
  "use strict";
  jQuery('input[id=' + val + ']').prop('checked', !(jQuery('input[id=' + val + ']').is(':checked')) );
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
  //alert()
}

//alert (foodsearch_cuisine_type());

function category_search(val){
  "use strict";
  jQuery('input[id=' + val + ']').prop('checked', !(jQuery('input[id=' + val + ']').is(':checked')) );
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
}
function foodsearch_update_loc(offset){
  "use strict";
  jQuery(".fds-distance" + offset + " span").html('<div class="fds-dot-animate"></div>');
  var data = jQuery('#frm_restaurant_listing').serialize();
  jQuery.ajax({
    type: "get",
    dataType: 'json',
    url: fronend_script_strings.url + 'wp/v1/update-loc',
    data: data,  
    beforeSend: function ( xhr ) {
      xhr.setRequestHeader( 'X-WP-Nonce', fronend_script_strings.nonce );      
     // xhr.setRequestHeader("Authorization", "Bearer 1bgF DO75 idzF oANw uC4c x74U");
    },
    success: function( data, txtStatus, xhr ) {
      jQuery.each( data, function( i, val ) {
        jQuery("#" + i).html(val);
      });

    }
  });

}


function foodsearch_update_counter(){
  "use strict";
  var $filter_counts = parseInt(jQuery('input[name="filter_counts"]').val());
  if ( $filter_counts ) {
    jQuery(".sb_cuisine small, #sb_delivery, #sb_take_away, #sb_rating5, #sb_rating4, #sb_rating3, #sb_rating2").html('<div class="fds-dot-animate"></div>');
    jQuery.ajax({
      type: "get",
      dataType: 'json',
      url: fronend_script_strings.url + 'wp/v1/update-counter',
      data: jQuery('#frm_restaurant_listing').serialize(),
      success: function(res){
        jQuery.each( res, function( i, val ) {
          jQuery("#" + i).html(val);

            // sorting the cusine types
            var $wrapper = jQuery('.cuisine-type');
            $wrapper.find('.sb_cuisine').sort(function (a, b) {
              return -jQuery(a).find("small").text() - -jQuery(b).find("small").text();
            })
            .appendTo( $wrapper );
            // sorting the cusine types

        });
      }
    });

  }


}

jQuery(document).on("click", ".cuisine-type input:checkbox, .options input:checkbox, .order_by input:radio, .fds-filter-rating input:radio", function(event) { 
  "use strict";
  foodsearch_frm_submit(0);
  foodsearch_update_counter();
});

jQuery(document).on('click', 'body', function(evnt) {
  "use strict";
  var this_target = jQuery(evnt.target);
  if ( !this_target.is('a.fds-res-filter-btn') && !this_target.parents('a.fds-res-filter-btn').length > 0) {
    jQuery(".fds-filter-sidebar").removeClass("fds-sidebar-active");
  }
  if ( !this_target.is('div.fds-res-dropdown-up') && !this_target.parents('div.fds-res-dropdown-up').length > 0) {
    jQuery(".fds-res-dropdown-sub").removeClass("fds-res-dropdown-active");
  }
});

jQuery(document).on("click", ".fds-res-filter-btn", function(event) { 
  "use strict";
  jQuery(".fds-filter-sidebar").toggleClass("fds-sidebar-active");
});

jQuery(document).on("click", ".fds-res-dropdown-up", function(event) { 
  "use strict";
  jQuery(".fds-res-dropdown-sub").toggleClass("fds-res-dropdown-active");
});

jQuery(document).on('click', function (e) {
  "use strict";
  if (jQuery(e.target).closest("#cookie_result").length === 0) {
      jQuery("#cookie_result").html('');
  }
});

jQuery(document).on("click", ".remove_cookie", function(event) { 
  "use strict";
  jQuery(this).parent().addClass( "suggestion-hide" ).css({'display':'none'});
  jQuery.ajax({
    type: "get",
    dataType: 'json',
    url: fronend_script_strings.url + 'wp/v1/remove-cookie',
    data: { "keyword": jQuery(this).attr("val") },
    success: function(res){
    }
  });
});

jQuery(document).on("keydown", "#search_field", function(event) { 
  "use strict";
  if (event.keyCode == 13) {
    var frm_id = jQuery(this).closest("form").attr("id");
    if ( frm_id != "frm_restaurant_listing" ){
      jQuery("form").first().trigger('submit');
    }
    else {
      foodsearch_frm_submit(0);
      foodsearch_update_counter();
      event.preventDefault();
    }
  }
});

jQuery(document).on("keyup", "#search_field", function(event) { 
  "use strict";
  if ( (event.keyCode >= 65 && event.keyCode <= 90) || (event.keyCode >= 48 && event.keyCode <= 57) || event.keyCode == 8 || event.keyCode == 46 ) {
    foodsearch_show_suggestion();
  }
});
jQuery(document).on("mousedown, mouseup", "#search_field", function(event) { 
  "use strict";
  foodsearch_show_suggestion();
});
function foodsearch_show_suggestion() {
  "use strict";
  jQuery("#clear-search").hide();
  jQuery('.loader-search-field').show();
    jQuery.ajax({
      type: "get",
      dataType: 'json',
      url: fronend_script_strings.url + 'wp/v1/get-suggestion',
      data: { "keyword": jQuery("#search_field").val() },
      success: function(res){
        jQuery("#cookie_result").html(res.html);
        jQuery('.loader-search-field').hide();
        jQuery("#clear-search").show();
      }
    });
  
}
jQuery(document).on('click','.suggestion',function () {
  "use strict";
  var str = jQuery(this).html().replace(/(<([^>]+)>)/gi, "") ;
  jQuery("#search_field").val(str);
  var frm_id = jQuery(this).closest("form").attr("id");
  if ( frm_id != "frm_restaurant_listing" ){
    jQuery("form").first().trigger('submit');
  }
  else {
    foodsearch_frm_submit(0);
    foodsearch_update_counter();
  }
});

jQuery(document).on('click','.fds-list',function () {
  "use strict";
    jQuery('input[name="style"]').val("list");
    jQuery(this).parent().addClass( "active" );
    jQuery(this).parent().next().removeClass( "active" );
    foodsearch_frm_submit(0);
});
jQuery(document).on('click','.fds-menu',function () {
  "use strict";
    jQuery('input[name="style"]').val("grid");
    jQuery(this).parent().addClass( "active" );
    jQuery(this).parent().prev().removeClass( "active" );
    foodsearch_frm_submit(0);
});

jQuery(document).on('click','.load_more',function () {
  "use strict";
  foodsearch_frm_submit(1);
});

function foodsearch_frm_submit(load_more){
  "use strict";
  if ( load_more == 0 ) {
    jQuery('#offset').val(0);
    jQuery('#loader').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
  }
  else if ( load_more == 1 ) {
    jQuery('.loader-load-more').html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>').removeClass("fds-has-bg");
  }
  else if ( load_more == 2 ) {
    jQuery('.loader-on-scroll').show();
  }
    
    var view_mod = jQuery('input[name="style"]').val();
    var delivery = jQuery('input[name="delivery"]:checked').val();
      delivery = ( typeof delivery == "undefined" ) ? "" : "&delivery=" + delivery;
    var take_away = jQuery('input[name="take_away"]:checked').val();
      take_away = ( typeof take_away == "undefined" ) ? "" : "&take_away=" + take_away;
    var order_by = jQuery('input[name="order"]:checked').val();
      order_by = ( typeof order_by == "undefined" ) ? "" : "&order=" + order_by;
    var ratings = jQuery('input[name="ratings"]:checked').val();
      ratings = ( typeof ratings == "undefined" ) ? "" : "&ratings=" + ratings;
    var keyword = jQuery('input[name="keyword"]').val();
      keyword = ( keyword == "" ) ? "" : "&keyword=" + keyword;

    var cuisine_type = "";
    jQuery('input[name="cuisine[]"]:checked').each(function() {
      cuisine_type += jQuery(this).val() + ",";
    });
    cuisine_type = ( cuisine_type == "" ) ? "" : "&cuisine=" + cuisine_type;
    var oldURL = window.location.href;
    if (history.pushState) {
        var newUrl = "?style=" + view_mod + cuisine_type + delivery + take_away + order_by + ratings + keyword ;
        window.history.pushState({ path: newUrl }, '', newUrl);
    }

    jQuery.ajax({
        type: "get",
        dataType: 'json',
        url: fronend_script_strings.url + 'wp/v1/call-restaurants',
        data: jQuery('#frm_restaurant_listing').serialize(),
        success: function(res){
          if ( load_more == 1 || load_more == 2 ) {
            jQuery('#offset, #total_items').remove();
            jQuery('#restaurant_area').append(res.html);
            // updating the display counting label
            jQuery('.offset').html( jQuery('#offset').val() );
          }
          else {
            jQuery('#restaurant_area').html(res.html);
          }
          jQuery('#loader').html('');
          jQuery('.loader-load-more').html('load more').addClass("fds-has-bg");
          if ( parseInt(jQuery('#offset').val()) >= parseInt(jQuery('#total_items').val()) ){
            jQuery('.load_more').hide();
          }
          else jQuery('.load_more').show();

          jQuery('.loader-on-scroll').hide();
          // updating the total records
          jQuery('.fds-total-items span').html( parseInt(jQuery('#offset').val()) );
          foodsearch_update_loc( jQuery('#offset').val() );
        }
    });

    jQuery("#cookie_result").html("");
    jQuery(".clear-all").show();
    if ( jQuery("#search_field").val() !== "" ) jQuery("#clear-search").show();
    else jQuery("#clear-search").hide();

    

}

  jQuery(window).on("scroll", function() {
    "use strict";
    if ( jQuery('#pagination').val() == "on_scroll" ) {
      if(jQuery(window).scrollTop() + jQuery(window).height() >= jQuery(document).height()){
        if ( parseInt(jQuery('#offset').val()) < parseInt(jQuery('#total_items').val()) ){
          foodsearch_frm_submit(2);
        }
      }
    }
  });

  window.onload = function () { 
    "use strict";
    foodsearch_update_counter();
    foodsearch_update_loc( jQuery('#offset').val() );
  }
